------------------------------------------------------------------------------------------------------------------------
--                                                 WARNING!                                                           --
--                      To those that wouldst devine the secrets of thy NecroForge                                    --
--              The Demons that wroteth the NecroForge dost speak in riddles & absence of self,                       --
--              to decipher the Demons riddles & in so doing understandeth the secrets contained                      --
--              within thy NecroForge, first thou must knoweth self. Once thou knoweth self the                       --
--              riddles of thy NecroForge will be revealed....eth & thou willst be one step closer                    --
--              to understanding the secrets contained within....                                                     --
--                                                                          ....ExcentriCreation (2013)               --
------------------------------------------------------------------------------------------------------------------------
--                                         	  Continued by Svarog 	              									  --
------------------------------------------------------------------------------------------------------------------------
require "ISUI/ISLayoutManager"
local NecroVision = ISCollapsableWindow:derive("NecroVision");
local NecroCipher = ISScrollingListBox:derive("NecroCipher");
local NecroScan = ISScrollBar:derive("NecroScan");
local NecroListen = ISButton:derive("NecroListen");
local NecroStudy = ISTextEntryBox:derive("NecroStudy");
local NecroDimension = ISPanel:derive("NecroDimension");
local NecroElement = ISUIElement:derive("NecroElement");

-- NecroForge Variables
local	NecroFlag 				= {}
		NecroFlag.God 			= false;
		NecroFlag.Build 		= false;
		NecroFlag.Farm 			= false;
		NecroFlag.Ghost 		= false;
		NecroFlag.Noclip 		= false;
		NecroFlag.Flight 		= false;
		NecroFlag.SpeedLimiter	= false;
		NecroFlag.SuperSpeed	= false;
		NecroFlag.Weight 		= false;
		NecroFlag.Ground 		= false;
		NecroFlag.Debug 		= false;
		NecroFlag.Info 			= true;
		NecroFlag.Icons 		= true;
		NecroFlag.Count 		= 1;
		NecroFlag.Z 			= 0;
		NecroFlag.EventDebug 	= false;
		NecroFlag.EventBrush 	= false;
		NecroFlag.EventOnKey 	= false;
		NecroFlag.Brush			= false;
		NecroFlag.BrushType		= nil;
		NecroFlag.BrushSpec		= nil;
		NecroFlag.Barricade		= "Plank";
		NecroFlag.FloorRep		= false;
		NecroFlag.OverRep		= true;
		NecroFlag.OverOnly		= false;
		NecroFlag.OverOnlyTemp	= false;
		NecroFlag.ShowGhost		= true;
		NecroFlag.ClonerHelp	= true;
		NecroFlag.ListMin		= 0;
		NecroFlag.ListMax		= 250;
		NecroFlag.ListStep		= 250;
		NecroFlag.ListNum		= 1;
		NecroFlag.ListNumMax	= 1;
-- Tile/Object Clone Variables
local 	NecroPicked 			= {}
		NecroPicked.Object 		= false;
		NecroPicked.Floor 		= nil;
		NecroPicked.Type 		= nil;
		NecroPicked.Sprite 		= nil;
		NecroPicked.OpenSprite	= nil;
		NecroPicked.Overlayed 	= nil;
		NecroPicked.Propane		= nil; 
		NecroPicked.PropaneTank	= nil; 
		NecroPicked.FuelAmount	= nil;
		NecroPicked.North		= nil;
		NecroPicked.Locked		= nil;
		NecroPicked.PermaLocked = nil;
		NecroPicked.Health		= nil;
		NecroPicked.MaxHealth	= nil;
		NecroPicked.KeyID		= nil;
		NecroPicked.DeviceData	= nil;
		NecroPicked.Facing		= nil;
		NecroPicked.Noffset		= nil;
		NecroPicked.Soffset		= nil;
		NecroPicked.Woffset		= nil;
		NecroPicked.Eoffset		= nil;
		NecroPicked.SpriteSheet = nil;
		NecroPicked.SpriteID	= nil;
		NecroPicked.SpriteProps = nil;
		NecroPicked.MultiSprite = nil;
		NecroPicked.Overlays 	= {}
-- Keys [ToDo - Rebinding] - [Placeholder]
local	NecroKeys 				= {}
		NecroKeys.MoveUp		= 201;
		NecroKeys.MoveDown		= 209;
		NecroKeys.BrushSpecial	= 19;
		NecroKeys.TOCPick		= 19;
		NecroKeys.TOCOverOnly	= 33;
		NecroKeys.TOCOverRep	= 20;
		NecroKeys.TOCRemover	= 45;
		NecroKeys.TOCGhost		= 34;
		NecroKeys.TOCHelp		= 53;
		NecroKeys.TOCSpriteN	= 27;
		NecroKeys.TOCSpriteP	= 26;
		NecroKeys.ToggleNF		= 41;
		NecroKeys.TOCRotateN	= 200;
		NecroKeys.TOCRotateW	= 205;
		NecroKeys.TOCRotateS	= 208;
		NecroKeys.TOCRotateE	= 203;
		NecroKeys.Rebinding		= false;
		NecroKeys.RebindID		= nil;

function NecroVision:Summon()
    NecroEchos = {};
    local NecroSys = nil;
    local NecroFragment = nil;
    local NecroSpeak = false;
    local NecroSummon = getFileReader("NecroEchos.ini", true);
    if NecroSummon:readLine() == nil then
        NecroChild.Toggle = 41
        NecroVision:Consort()
        return;
    else
        while true do
            NecroFragment = NecroSummon:readLine();
            if NecroSpeak then
                if NecroFragment == nil then
                    NecroSummon:close();
                    break;
                else
                    table.insert(NecroEchos, NecroFragment);
                end
            else
                NecroSys = string.split(NecroFragment, "=");
                NecroChild.Toggle = NecroSys[2];
                while NecroFragment ~= "[Favorites]" do
                    NecroFragment = NecroSummon:readLine();
                end
                NecroSpeak = not NecroSpeak;
            end
        end
    end
end

function NecroVision:Add()
    local NecroSpeak = true;
    if NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected] ~= nil then
		getSoundManager():PlaySound("NecroForge", false, 0.8);
        for NecroRiddleCount, NecroRiddleSpeak in ipairs(NecroEchos) do
            if NecroRiddleSpeak == NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].ref then
                NecroSpeak = not NecroSpeak;
                break;
            end
        end
        if NecroSpeak then
            table.insert(NecroEchos, NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].ref);

            NecroVision:Consort();
        end
    end
end

function NecroVision:Remove()
    if NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected] ~= nil then
		getSoundManager():PlaySound("NecroForge", false, 0.8);
        for NecroRiddleCount, NecroRiddleSpeak in ipairs(NecroEchos) do
            if NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].ref == NecroRiddleSpeak then
                 table.remove(NecroEchos, NecroRiddleCount);
            end
        end
        table.remove(NecroChild.NecroCipher.items, NecroChild.NecroCipher.selected);
        NecroChild.NecroCipher.count = NecroChild.NecroCipher.count - 1;
        NecroChild.NecroCipher:setScrollHeight(NecroChild.NecroCipher:getScrollHeight() - NecroChild.NecroCipher.itemheight);

        NecroVision:Consort();

        NecroScanRefresh();
    end
end

function NecroVision:Consort()
    local NecroSummon = getFileWriter("NecroEchos.ini", true, false);

    NecroSummon:write("[KeyBindings]" .. "\r\n");
    NecroSummon:write("NecroForge=" .. NecroChild.Toggle .. "\r\n");

    NecroSummon:write("[Favorites]" .. "\r\n");
    for NecroRiddleCount, NecroRiddleSpeak in ipairs(NecroEchos) do
        NecroSummon:write(NecroRiddleSpeak .. "\r\n");
    end
    NecroSummon:close();
end

function NecroVision:Commence()
	print("[NecroForge] - Commencing")
    NecroChild = NecroVision:new(0, 0, 0, 0);
    NecroPorthole = NecroListen:new(getCore():getScreenWidth() - 50, getCore():getScreenHeight() - 50, 25, 25, nil, nil, NecroVision.Manifest);
    NecroPorthole.Sprite = getTexture("media/ui/NecroFragment_UI.png");
    if not NecroPorthole.Sprite then NecroPorthole.Sprite = getTexture("media/ui/NecroFragment_Button.png"); end
    NecroPorthole.Alt = true
	NecroFunctionWarn = NecroListen:new(getCore():getScreenWidth() - 50, getCore():getScreenHeight() - 78, 25, 25, nil, nil, NecroVision.DisableDebug);
    NecroFunctionWarn.Sprite = getTexture("media/ui/NecroFragment_Warning.png");
	NecroFunctionWarn.Alt = true
	NecroFunctionWarn:setVisible(false);
    NecroChild:addToUIManager();
    NecroPorthole:addToUIManager();
	NecroFunctionWarn:addToUIManager();
    NecroChild:setVisible(false);
    NecroPorthole:setVisible(true);
    NecroVision:Summon();
	print("[NecroForge] - Init Authorization Check")
	Events.OnTick.Add(NecroVision.Guardian);
	NecroSpeak();
end

function NecroVision:new(x, y, width, height)
    NecroChild = ISCollapsableWindow:new(x, y, width, height);
    setmetatable(NecroChild, self)
    self.__index = self
    NecroChild.NecroListen = {};
    NecroChild.NecroListen.Count = 0
    for NecroRiddleCount, NecroRiddleSpeak in ipairs(NecroList.Category) do
        NecroChild.NecroListen.Count = NecroChild.NecroListen.Count + 1
    end
    NecroChild.height = 16 + 3 + (math.ceil(NecroChild.NecroListen.Count + 2) * (25 + 3)) + 9;
    NecroChild.width = 350;
	NecroChild.x = 100;
	NecroChild.y = 100;
	NecroChild.pin = true;
    NecroChild.title = "- NecroForge -";
    NecroChild.minimumHeight = NecroChild.height;
    NecroChild.minimumWidth = NecroChild.width;
    NecroChild.extraUp = true;
    NecroChild.extraCount = 0;
    NecroChild.extraFrag = 0;
    NecroChild.advocate = true;
    return NecroChild;
end

function NecroVision:createChildren()
    -- Options Panel
    NecroChild.NecroDimension = NecroDimension:new(3 + 25 + 3, NecroChild.height - 150, NecroChild.width - (6 + 50 + 6), 150);
    NecroChild.NecroDimension:initialise();
    NecroChild:addChild(NecroChild.NecroDimension);

    -- CloseButton
    NecroChild.closeButton = ISButton:new(3, 0, 16, 16, "", NecroChild, ISCollapsableWindow.close);
    NecroChild.closeButton.borderColor.a = 0.0;
    NecroChild.closeButton.backgroundColor.a = 0;
    NecroChild.closeButton.backgroundColorMouseOver.a = 0;
    NecroChild.closeButton:initialise();
    NecroChild.closeButton:setImage(NecroChild.closebutton);
	NecroChild.closeButton:setImage(NecroChild.closeButtonTexture);
	NecroChild:addChild(NecroChild.closeButton);
	NecroChild.closeButton:setVisible(true);

    -- PinButton
    NecroChild.pinButton = ISButton:new(NecroChild.width - 19, 0, 16, 16, "", NecroChild, ISCollapsableWindow.pin);
    NecroChild.pinButton.anchorRight = true;
    NecroChild.pinButton.anchorLeft = false;
    NecroChild.pinButton.borderColor.a = 0.0;
    NecroChild.pinButton.backgroundColor.a = 0;
    NecroChild.pinButton.backgroundColorMouseOver.a = 0;
    NecroChild.pinButton:initialise();
    NecroChild.pinButton:setImage(NecroChild.pinbutton);
	NecroChild.pinButton:setImage(NecroChild.pinButtonTexture);
	NecroChild:addChild(NecroChild.pinButton);
	NecroChild.pinButton:setVisible(false);

    -- CollapseButton
    NecroChild.collapseButton = ISButton:new(NecroChild.width - 19, 0, 16, 16, "", NecroChild, ISCollapsableWindow.collapse);
    NecroChild.collapseButton.anchorRight = true;
    NecroChild.collapseButton.anchorLeft = false;
    NecroChild.collapseButton.borderColor.a = 0.0;
    NecroChild.collapseButton.backgroundColor.a = 0;
    NecroChild.collapseButton.backgroundColorMouseOver.a = 0;
    NecroChild.collapseButton:initialise();
    NecroChild.collapseButton:setImage(NecroChild.collapsebutton);
	NecroChild.collapseButton:setImage(NecroChild.collapseButtonTexture);
	NecroChild:addChild(NecroChild.collapseButton);
    NecroChild.collapseButton:setVisible(true);

    -- Search Bar
    NecroChild.NecroStudy = NecroStudy:new("", 9 + 50 + 4, 64 + 3 + 3, NecroChild.width - (18 + 100 + 8), 19);
    NecroChild.NecroStudy.isFocused = false;
    NecroChild.NecroStudy.Study = "";
    NecroChild.NecroStudy.Patience = nil;
    NecroChild.NecroStudy:initialise();
    NecroChild:addChild(NecroChild.NecroStudy);
	
	-- Blueprints
    NecroChild.NecroBlueprint = NecroStudy:new("Module.ItemID", 9 + 50 + 4, 16 + 3 + 3, NecroChild.width - (18 + 100 + 8), 19);
    NecroChild.NecroBlueprint.isFocused = false;
    NecroChild.NecroBlueprint:initialise();
    NecroChild:addChild(NecroChild.NecroBlueprint);
	
	-- Coordinate X
    NecroChild.NecroCartographyX = NecroStudy:new("X", 9 + 50 + 4, 40 + 3 + 3, NecroChild.width - (18 + 225 + 8), 19);
    NecroChild.NecroCartographyX.isFocused = false;
    NecroChild.NecroCartographyX:initialise();
    NecroChild:addChild(NecroChild.NecroCartographyX);
	
	-- Coordinate Y
    NecroChild.NecroCartographyY = NecroStudy:new("Y", 9 + 150 + 4, 40 + 3 + 3, NecroChild.width - (18 + 225 + 8), 19);
    NecroChild.NecroCartographyY.isFocused = false;
    NecroChild.NecroCartographyY:initialise();
    NecroChild:addChild(NecroChild.NecroCartographyY);
	
	-- Coordinate Z
    NecroChild.NecroCartographyZ = NecroStudy:new("Z", 9 + 250 + 4, 40 + 3 + 3, NecroChild.width - (18 + 300 + 8), 19);
    NecroChild.NecroCartographyZ.isFocused = false;
    NecroChild.NecroCartographyZ:initialise();
    NecroChild:addChild(NecroChild.NecroCartographyZ);

    -- Search Button
    NecroChild.NecroListen.Study = NecroListen:new(NecroChild.width - (6 + 50 + 4), 68 + 3, 25, 25, nil, nil, NecroVision.Study);
    NecroChild.NecroListen.Study.tooltip = "Search";
    NecroChild.NecroListen.Study.Sprite = getTexture("media/ui/NecroFragment_Study.png");
    NecroChild.NecroListen.Study:initialise();
    NecroChild:addChild(NecroChild.NecroListen.Study);
	
	-- Spawn Anything Button
    NecroChild.NecroListen.AnyForge = NecroListen:new(NecroChild.width - (6 + 50 + 4), 16 + 3, 25, 25, nil, nil, NecroVision.AnyForge);
	NecroChild.NecroListen.AnyForge.Creation = getSpecificPlayer(0):getInventory();
    NecroChild.NecroListen.AnyForge.tooltip = "Spawn Module.ItemID (Case Sensitive)";
    NecroChild.NecroListen.AnyForge.Sprite = getTexture("media/ui/NecroFragment_ForgeSmall.png");
    NecroChild.NecroListen.AnyForge:initialise();
    NecroChild:addChild(NecroChild.NecroListen.AnyForge);
	
	-- Remove Anything Button
    NecroChild.NecroListen.AnyRemove = NecroListen:new(NecroChild.width - (6 + 305 + 4), 16 + 3, 25, 25, nil, nil, NecroVision.AnyRemove);
	NecroChild.NecroListen.AnyRemove.Creation = getSpecificPlayer(0):getInventory();
    NecroChild.NecroListen.AnyRemove.tooltip = "Remove Module.ItemID (Case Sensitive)";
    NecroChild.NecroListen.AnyRemove.Sprite = getTexture("media/ui/NecroFragment_RemoveSmall.png");
    NecroChild.NecroListen.AnyRemove:initialise();
    NecroChild:addChild(NecroChild.NecroListen.AnyRemove);
	
	-- Teleport to Coordinates
    NecroChild.NecroListen.GotoCoord = NecroListen:new(NecroChild.width - (6 + 50 + 4), 42 + 3, 25, 25, nil, nil, NecroVision.GotoCoord);
	NecroChild.NecroListen.GotoCoord.Creation = getSpecificPlayer(0):getInventory();
    NecroChild.NecroListen.GotoCoord.tooltip = "Teleport to X, Y, Z";
    NecroChild.NecroListen.GotoCoord.Sprite = getTexture("media/ui/NecroFragment_TeleportSmall.png");
    NecroChild.NecroListen.GotoCoord:initialise();
    NecroChild:addChild(NecroChild.NecroListen.GotoCoord);
	
	-- Get Coordinates
    NecroChild.NecroListen.GetCoord = NecroListen:new(NecroChild.width - (6 + 305 + 4), 42 + 3, 25, 25, nil, nil, NecroVision.GetCoord);
	NecroChild.NecroListen.GetCoord.Creation = getSpecificPlayer(0):getInventory();
    NecroChild.NecroListen.GetCoord.tooltip = "Get Current X, Y, Z";
    NecroChild.NecroListen.GetCoord.Sprite = getTexture("media/ui/NecroFragment_CoordSmall.png");
    NecroChild.NecroListen.GetCoord:initialise();
    NecroChild:addChild(NecroChild.NecroListen.GetCoord);

    -- ScrollBox
    NecroChild.NecroCipher = NecroCipher:new(3 + 25 + 3, 16 + 3 + 75 + 2, NecroChild.width - (6 + 50 + 6), NecroChild.height - (16 + 6 + 125 + 4 + 9));
    NecroChild.NecroCipher.onmousedblclick = NecroVision.NecroExecute;
    NecroChild.NecroCipher.itemheight = 25
    NecroChild.NecroCipher:initialise();
    NecroChild:addChild(NecroChild.NecroCipher);

    -- ScrollBar I
    NecroChild.NecroScanI = NecroScan:new(NecroChild.NecroCipher, true);
    NecroChild.NecroScanI.x = NecroChild.width - (3 + 25 + 3 + 13);
    NecroChild.NecroScanI.Truth = true;
    NecroChild.NecroScanI:initialise();
    NecroChild:addChild(NecroChild.NecroScanI);

    -- ScrollBar II
    NecroChild.NecroScanII = NecroScan:new(NecroChild.NecroCipher, true);
    NecroChild.NecroScanII.x = 3 + 25 + 3;
    NecroChild.NecroScanII.Truth = false;
    NecroChild.NecroScanII:initialise();
    NecroChild:addChild(NecroChild.NecroScanII);

    -- Add/Remove Favorites Button
    NecroChild.NecroListen.AddRem = NecroListen:new(3 + 25 + 4 + 3, NecroChild.height - (9 + 3 + 25), 25, 25, nil, nil, NecroVision.Add);
    NecroChild.NecroListen.AddRem.tooltip = "Add to Favorites";
    NecroChild.NecroListen.AddRem.Sprite = getTexture("media/ui/NecroFragment_Fav.png");
    NecroChild.NecroListen.AddRem.Sprite2 = getTexture("media/ui/NecroFragment_PlusFav.png");
    NecroChild.NecroListen.AddRem.Sprite3 = getTexture("media/ui/NecroFragment_MinusFav.png");
    NecroChild.NecroListen.AddRem.SpriteOver = getTexture("media/ui/NecroFragment_PlusFav.png");
    NecroChild.NecroListen.AddRem:initialise();
    NecroChild:addChild(NecroChild.NecroListen.AddRem);
	
	-- Remove Button
    NecroChild.NecroListen.Remove = NecroListen:new(NecroChild.width - (3 + 25), NecroChild.height - (53 + 3 + 9), 25, 25, nil, nil, NecroVision.RemoveItem);
    NecroChild.NecroListen.Remove.Damned = getSpecificPlayer(0):getInventory();
    NecroChild.NecroListen.Remove.tooltip = "Remove";
    NecroChild.NecroListen.Remove.Sprite = getTexture("media/ui/NecroFragment_Remove.png");
    NecroChild.NecroListen.Remove:initialise();
    NecroChild:addChild(NecroChild.NecroListen.Remove);
	
    -- Spawn Button
    NecroChild.NecroListen.Spawn = NecroListen:new(NecroChild.width - (3 + 25), NecroChild.height - (81 + 3 + 9), 25, 25, nil, nil, NecroVision.NecroExecute);
    NecroChild.NecroListen.Spawn.Damned = getSpecificPlayer(0):getInventory();
    NecroChild.NecroListen.Spawn.tooltip = "Forge";
    NecroChild.NecroListen.Spawn.Sprite = getTexture("media/ui/NecroFragment_Forge.png");
    NecroChild.NecroListen.Spawn:initialise();
    NecroChild:addChild(NecroChild.NecroListen.Spawn);
	
	--Page Buttons
    NecroChild.NecroListen.PageNext = NecroListen:new(NecroChild.width - (3 + 205), NecroChild.height - (51 + 3 + 9), 22, 22, nil, nil, NecroVision.PageNext);
    NecroChild.NecroListen.PageNext.tooltip = "Next Page";
    NecroChild.NecroListen.PageNext.Sprite = getTexture("media/ui/NecroFragment_PageNext.png");
    NecroChild.NecroListen.PageNext:initialise();
    NecroChild:addChild(NecroChild.NecroListen.PageNext);
	
	NecroChild.NecroListen.PagePrevious = NecroListen:new(NecroChild.width - (3 + 295), NecroChild.height - (51 + 3 + 9), 22, 22, nil, nil, NecroVision.PagePrev);
    NecroChild.NecroListen.PagePrevious.tooltip = "Previous Page";
    NecroChild.NecroListen.PagePrevious.Sprite = getTexture("media/ui/NecroFragment_PagePrevious.png");
    NecroChild.NecroListen.PagePrevious:initialise();
    NecroChild:addChild(NecroChild.NecroListen.PagePrevious);
	
	-- Reset Spawn Amount Button
    NecroChild.NecroListen.ResetCounter = NecroListen:new(NecroChild.width - (3 + 25), NecroChild.height - (109 + 3 + 9), 25, 25, nil, nil, NecroVision.ResetCounter);
    NecroChild.NecroListen.ResetCounter.tooltip = "Reset Control Functions";
    NecroChild.NecroListen.ResetCounter.Sprite = getTexture("media/ui/NecroFragment_Warning.png");
    NecroChild.NecroListen.ResetCounter:initialise();
	NecroChild.NecroListen.ResetCounter:setVisible(false);
    NecroChild:addChild(NecroChild.NecroListen.ResetCounter);

    -- All Type Filter Button
    NecroChild.NecroListen.All = NecroListen:new(3, 16 + 3, 25, 25, nil, nil, NecroSpeak);
    NecroChild.NecroListen.All.tooltip = "All";
    NecroChild.NecroListen.All.Sprite = getTexture("media/ui/NecroFragment_List.png");
    NecroChild.NecroListen.All:initialise();
    NecroChild:addChild(NecroChild.NecroListen.All);

    -- Cycle Filter Buttons
    NecroChild.NecroListen.NecroPosY = 16 + 3 + 25 + 3;
    NecroChild.NecroListen.NecroPosX = 3
    for NecroRiddleCount, NecroRiddleSpeak in ipairs(NecroList.Category) do
        NecroChild.NecroListen[NecroRiddleSpeak] = NecroListen:new(NecroChild.NecroListen.NecroPosX, NecroChild.NecroListen.NecroPosY, 25, 25, nil, NecroRiddleSpeak, NecroSpeak);
        NecroChild.NecroListen[NecroRiddleSpeak].tooltip = NecroRiddleSpeak;
        NecroChild.NecroListen[NecroRiddleSpeak].Sprite = getTexture("media/ui/NecroFragment_" .. NecroRiddleSpeak .. ".png");
        if not NecroChild.NecroListen[NecroRiddleSpeak].Sprite then
            NecroChild.NecroListen[NecroRiddleSpeak].Sprite = getTexture("media/ui/NecroFragment_Literature.png");
        end
        NecroChild.NecroListen[NecroRiddleSpeak]:initialise();
        NecroChild:addChild(NecroChild.NecroListen[NecroRiddleSpeak]);
        NecroChild.NecroListen.NecroPosY = NecroChild.NecroListen.NecroPosY + (25 + 3);
    end
	
	-- Cycle Secondary Filter Buttons
    NecroChild.NecroListen.NecroPosYb = 16 + 3;
    NecroChild.NecroListen.NecroPosXb = (NecroChild.width - (3 + 25))
    for NecroRiddleCount, NecroRiddleSpeak in ipairs(NecroList.SecondaryCategory) do
        NecroChild.NecroListen[NecroRiddleSpeak] = NecroListen:new(NecroChild.NecroListen.NecroPosXb, NecroChild.NecroListen.NecroPosYb, 25, 25, nil, NecroRiddleSpeak, NecroSpeak);
        NecroChild.NecroListen[NecroRiddleSpeak].tooltip = NecroRiddleSpeak;
        NecroChild.NecroListen[NecroRiddleSpeak].Sprite = getTexture("media/ui/NecroFragment_" .. NecroRiddleSpeak .. ".png");
        if not NecroChild.NecroListen[NecroRiddleSpeak].Sprite then
            NecroChild.NecroListen[NecroRiddleSpeak].Sprite = getTexture("media/ui/NecroFragment_Functions.png");
        end
        NecroChild.NecroListen[NecroRiddleSpeak]:initialise();
        NecroChild:addChild(NecroChild.NecroListen[NecroRiddleSpeak]);
        NecroChild.NecroListen.NecroPosYb = NecroChild.NecroListen.NecroPosYb + (25 + 3);
    end

    -- Favorites Button
    NecroChild.NecroListen.Fav = NecroListen:new(3, NecroChild.height - (9 + 3 + 25), 25, 25, nil, "Favorites", NecroSpeak);
    NecroChild.NecroListen.Fav.tooltip = "Favorites";
    NecroChild.NecroListen.Fav.Sprite = getTexture("media/ui/NecroFragment_Fav.png");
    NecroChild.NecroListen.Fav:initialise();
    NecroChild:addChild(NecroChild.NecroListen.Fav);

    -- Options Button
    NecroChild.NecroListen.Custom = NecroListen:new(NecroChild.width - (3 + 25), NecroChild.height - (25 + 3 + 9), 25, 25, nil, nil, NecroVision.Extra);
    NecroChild.NecroListen.Custom.tooltip = "Options";
    NecroChild.NecroListen.Custom.Sprite = getTexture("media/ui/NecroFragment_Options.png");
    NecroChild.NecroListen.Custom:initialise();
    NecroChild:addChild(NecroChild.NecroListen.Custom);
	
	-- Items Per Page
	NecroChild.PageAmount = ISComboBox:new(NecroChild.width - (3 + 85), NecroChild.height - (50 + 3 + 9), 50, 20, NecroVision, NecroVision.PageAmount);
	NecroChild.PageAmount:initialise();
	NecroChild.PageAmount:addOption(tostring(250))
	NecroChild.PageAmount:addOption(tostring(500))
	NecroChild.PageAmount:addOption(tostring(750))
	NecroChild.PageAmount:addOption(tostring(1000))
	NecroChild:addChild(NecroChild.PageAmount)

end

function NecroVision:PageAmount(_sel)
	local Selected = _sel.selected
	if Selected == 1 then
		NecroFlag.ListStep = 250
	elseif Selected == 2 then
		NecroFlag.ListStep = 500
	elseif Selected == 3 then
		NecroFlag.ListStep = 750
	elseif Selected == 4 then
		NecroFlag.ListStep = 1000
	end
	NecroSpeak()
end

function NecroVision:PageNext()
	if NecroFlag.ListNum < NecroFlag.ListNumMax then
		getSoundManager():PlaySound("NecroSpark", false, 0.2);
		NecroFlag.ListMin = NecroFlag.ListMin + NecroFlag.ListStep
		NecroFlag.ListMax = NecroFlag.ListMax + NecroFlag.ListStep
		NecroFlag.ListNum = NecroFlag.ListNum + 1
	end
end

function NecroVision:PagePrev()
	if NecroFlag.ListMin > 0 and NecroFlag.ListNum > 1 then
		getSoundManager():PlaySound("NecroSpark", false, 0.2);
		NecroFlag.ListMin = NecroFlag.ListMin - NecroFlag.ListStep
		NecroFlag.ListMax = NecroFlag.ListMax - NecroFlag.ListStep
		NecroFlag.ListNum = NecroFlag.ListNum - 1
	end
end

function NecroDimension:createChildren()
    NecroChild.NecroDimension.Toggle = NecroListen:new(150, 47, 75, 25, nil, nil, NecroVision.Bind);
    NecroChild.NecroDimension.Toggle.Alt = true;
    NecroChild.NecroDimension.Toggle.Active = false;
    NecroChild.NecroDimension.Toggle.Binding = false;
    NecroChild.NecroDimension.Toggle:initialise();
    NecroChild.NecroDimension:addChild(NecroChild.NecroDimension.Toggle);
end

function NecroVision:DummyFunction()

end

function NecroVision:collapse()
    if ISMouseDrag.dragging and #ISMouseDrag.dragging > 0 then
        return;
    end
    NecroChild.pin = false;
    NecroChild.collapseButton:setVisible(false);
    NecroChild.pinButton:setVisible(true);
    NecroChild.pinButton:bringToTop();
end

function NecroVision:setPinned()
    NecroChild.pin = true;
    NecroChild.collapseButton:setVisible(true);
    NecroChild.pinButton:setVisible(false);
    NecroChild.collapseButton:bringToTop();
end

function NecroDimension:prerender()
	if NecroChild.extraFrag == 150 then
	    NecroChild.NecroDimension.Toggle.Active = true;
	else
	    NecroChild.NecroDimension.Toggle.Active = false;
	end
	NecroChild.NecroDimension.javaObject:setY(NecroChild.NecroDimension.y + NecroChild.extraFrag);
	NecroChild.NecroDimension:setStencilRect(0, 150 - NecroChild.extraFrag, NecroChild.NecroDimension.width + 1, NecroChild.NecroDimension.height);
	NecroChild.NecroDimension:drawRect(0, 0 - 1, NecroChild.NecroDimension.width, NecroChild.NecroDimension.height, 0.7, 0, 0, 0);
	NecroChild.NecroDimension:drawRectBorder(0, 0 - 1, NecroChild.NecroDimension.width, NecroChild.NecroDimension.height, 1, 0.4, 0.4, 0.4);
    NecroChild.NecroDimension:drawText("Key Bindings", 10, 10, 1, 1, 1, 1, UIFont.Small);
    NecroChild.NecroDimension:drawRect(10, 30, NecroChild.NecroDimension.width - 20, 1, 1, 0.4, 0.4, 0.4);
    NecroChild.NecroDimension:drawText("Toggle NF", 75, 50, 1, 1, 1, 1, UIFont.Small);
	NecroChild.NecroDimension:drawRectBorder(0, NecroChild.NecroDimension.height - 9, NecroChild.NecroDimension.width, 9, 1, 0.4, 0.4, 0.4);
	NecroChild.NecroDimension:drawTextureScaled(NecroChild.statusbarbkg, 2,  NecroChild.NecroDimension.height - 7, NecroChild.NecroDimension.width - 4, 6, 1, 1, 1, 1);
    if NecroChild.extraCount > 0 then
        NecroChild.extraFrag = NecroChild.extraFrag + 10;
        NecroChild.extraCount = NecroChild.extraCount - 1;
    elseif NecroChild.extraCount < 0 then
        NecroChild.extraFrag = NecroChild.extraFrag - 10;
        NecroChild.extraCount = NecroChild.extraCount + 1;
    end
end

function NecroDimension:render()
    NecroChild.NecroDimension:clearStencilRect();
end

function NecroElement:render()
    NecroBind:drawRect(0, 0, NecroBind.width, NecroBind.height, 0.5, 0.5, 0.5, 0.5);
    NecroBind:drawTextCentre("Press Key to Bind", NecroBind.width / 2, (NecroBind.height / 2) - 10, 1, 1, 1, 1, UIFont.Medium);
end

function NecroElement:onMouseDown(x, y)
    NecroVision:Bind()
end

function NecroElement:onMouseDownOutside(x, y)
    NecroVision:Bind()
end

function NecroVision:Bind()
    NecroChild.NecroDimension.Toggle.Binding = not NecroChild.NecroDimension.Toggle.Binding;
    if NecroChild.NecroDimension.Toggle.Binding and not NecroChild.NecroDimension.Toggle.Binded then
        NecroChild.NecroDimension.Toggle.Binded = not NecroChild.NecroDimension.Toggle.Binded;
        local NecroRiddle = {};
        NecroRiddle.x = NecroChild.x + NecroChild.NecroDimension.x + 1;
        NecroRiddle.y = NecroChild.y + NecroChild.NecroDimension:getY() + 1;
        NecroRiddle.width = NecroChild.NecroDimension.width - 2;
        NecroRiddle.height = NecroChild.NecroDimension.height - 2;
        NecroBind = NecroElement:new(NecroRiddle.x, NecroRiddle.y, NecroRiddle.width, NecroRiddle.height);
        NecroBind:addToUIManager();
        NecroBind:setVisible(true);
        NecroBind.speed = getGameSpeed();
        setGameSpeed(0);
    end
    if not NecroChild.NecroDimension.Toggle.Binding and NecroChild.NecroDimension.Toggle.Binded then
        NecroChild.NecroDimension.Toggle.Binded = not NecroChild.NecroDimension.Toggle.Binded;
        setGameSpeed(NecroBind.speed);
        NecroBind:setVisible(false);
        NecroBind:removeFromUIManager()
        NecroBind = nil;
    end
end

function NecroVision:Study()
    if NecroChild.NecroStudy.isFocused then
        NecroChild.NecroStudy:unfocus()
        NecroChild.NecroStudy.isFocused = not NecroChild.NecroStudy.isFocused;
        NecroSpeak();
    else
        NecroChild.NecroStudy:focus();
        NecroChild.NecroStudy.isFocused = not NecroChild.NecroStudy.isFocused;
    end
end

function NecroVision:Extra()
    if NecroChild.extraCount == 0 then
        getSoundManager():PlaySound("NecroPiston", false, 0.5);
        if NecroChild.extraUp then
            NecroChild.extraUp = not NecroChild.extraUp;
            NecroChild.extraCount = NecroChild.extraCount + 15;
        else
            NecroChild.extraUp = not NecroChild.extraUp;
            NecroChild.extraCount = NecroChild.extraCount - 15;
        end
    end
end

function NecroVision:onMouseMoveOutside(dx, dy)
	local NecroRiddle = {};
	NecroRiddle.x = getMouseX() - NecroChild.x - NecroChild.NecroDimension.x;
	NecroRiddle.y = getMouseY() - NecroChild.y - NecroChild.NecroDimension:getY();
	NecroChild.mouseOver = false;
	if NecroChild.moving then
		NecroChild:setX(NecroChild.x + dx);
		NecroChild:setY(NecroChild.y + dy);
		NecroChild:bringToTop();
	end
    if (NecroRiddle.x >= 0) and (NecroRiddle.x <= NecroChild.NecroDimension.width) then
        if (NecroRiddle.y >= 0) and (NecroRiddle.y <= NecroChild.NecroDimension.height) then
            NecroChild.mouseOver = true;
        end
    end
	if not NecroChild.pin and not NecroChild.mouseOver then
		NecroChild.collapseCounter = NecroChild.collapseCounter + 1;
		if NecroChild.collapseCounter > 20 and not NecroChild.isCollapsed then
			NecroChild.isCollapsed = true;
			NecroChild:setMaxDrawHeight(15);
		end
	end
end

function NecroVision:prerender()
	local NecroRiddle = {};
	NecroRiddle.height = NecroChild.height;
	NecroRiddle.TxTH = NecroChild.height - (19 + 34 + 9) + 2;
	NecroRiddle.TxTM = ((NecroChild.width - (18 + 105 + 8)) / 2) + 9 + 50 + 4;
	if NecroChild.isCollapsed then
		if not NecroChild.NecroStudy.NecroEcho then
    		NecroChild.NecroStudy.NecroEcho = NecroChild.NecroStudy:getText();
    		NecroChild.NecroStudy:clear();
    		NecroChild.NecroStudy:unfocus();
        end
		NecroRiddle.height = 16;
	end
	NecroChild:setStencilRect(0, 0, NecroChild.width + 1, NecroRiddle.height);
	NecroChild:drawRect(0, 0, NecroChild.width, NecroRiddle.height, 0.8, 0, 0, 0);
	NecroChild:drawTextureScaled(NecroChild.titlebarbkg, 2, 1, NecroChild.width - 4, 14, 1, 1, 1, 1);
	NecroChild:drawRectBorder(0, 0, NecroChild.width, 16, 1, 0.4, 0.4, 0.4);
    NecroChild:drawTextCentre(NecroChild.title, NecroChild.width / 2, 1, 1, 1, 1, 1, UIFont.Small);
	if not NecroChild.isCollapsed then
		NecroChild:drawRectBorder(0, 16 - 1, 3 + 25 + 4, NecroChild.height - (9 + 16) + 2, 1, 0.4, 0.4, 0.4);
		NecroChild:drawRectBorder(NecroChild.width - (3 + 25 + 4), 16 - 1, 3 + 25 + 4, NecroChild.height - (9 + 16) + 2, 1, 0.4, 0.4, 0.4);
		NecroChild:drawRectBorder(3 + 25 + 3, 15, NecroChild.width - (6 + 50 + 6), 3 + 75 + 4, 1, 0.4, 0.4, 0.4);
		NecroChild:drawRectBorder(3 + 25 + 3, NecroChild.height - (9 + 3 + 25 + 3), NecroChild.width - (6 + 50 + 6), 3 + 25 + 4, 1, 0.4, 0.4, 0.4);
		NecroChild:drawRectBorder(3 + 25 + 3, NecroChild.height - (9 + 3 + 50 + 3), NecroChild.width - (6 + 50 + 6), 3 + 19 + 4, 1, 0.4, 0.4, 0.4);
		NecroChild:drawTextCentre(("Page "..NecroFlag.ListNum.."/"..NecroFlag.ListNumMax), NecroRiddle.TxTM - 65, NecroRiddle.TxTH, 1, 1, 1, 1, UIFont.small);
		NecroChild:drawTextCentre("Items per Page:", NecroRiddle.TxTM + 45, NecroRiddle.TxTH, 1, 1, 1, 1, UIFont.small);
		
	    NecroChild:drawRectBorder(0, 0, NecroChild.width, NecroChild.height, 1, 0.4, 0.4, 0.4);
		NecroChild:drawRectBorder(0, NecroChild.height - 9, NecroChild.width, 9, 1, 0.4, 0.4, 0.4);
		NecroChild:drawTextureScaled(NecroChild.statusbarbkg, 2,  NecroChild.height - 7, NecroChild.width - 4, 6, 1, 1, 1, 1);
		NecroChild:drawRectBorder(9 + 50 + 4, NecroChild.height - (19 + 6 + 9), NecroChild.width - (18 + 100 + 8), 19, 1, 0.4, 0.4, 0.4);
	end
    NecroChild:clearStencilRect();
end

function NecroVision:render()

end

function NecroVision:uncollapse()
	NecroChild.collapseCounter = 0;
	if NecroChild.isCollapsed and NecroChild:getMouseY() < 16 then
	    if NecroChild.NecroStudy.NecroEcho then
		    NecroChild.NecroStudy:setText(NecroChild.NecroStudy.NecroEcho);
		    NecroChild.NecroStudy.NecroEcho = nil;
		end
		NecroChild.isCollapsed = false;
		NecroChild:clearMaxDrawHeight();
		NecroChild.collapseCounter = 0;
	end
end

function NecroListen:onMouseDownOutside(x, y)
    local NecroRiddle = {};
    local NecroFragment = self;
    NecroRiddle.x = getMouseX() - NecroChild.x - NecroChild.NecroDimension.x;
    NecroRiddle.y = getMouseY() - NecroChild.y - NecroChild.NecroDimension:getY();
    if NecroFragment.Alt then
        if NecroChild.NecroDimension.Toggle.Active then
            if (NecroRiddle.x >= NecroFragment.x) and (NecroRiddle.x <= NecroFragment.x + NecroFragment.width) then
                if (NecroRiddle.y >= NecroFragment.y) and (NecroRiddle.y <= (NecroFragment.y + NecroFragment.height)) then
                    NecroVision:Bind();
                end
            end
        end
    end
end

function NecroListen:onMouseMoveOutside(dx, dy)
	local NecroRiddle = {};
	local NecroFragment = self;
	NecroRiddle.x = getMouseX() - NecroChild.x - NecroChild.NecroDimension.x;
	NecroRiddle.y = getMouseY() - NecroChild.y - NecroChild.NecroDimension:getY();
	NecroFragment.mouseOver = false;
	if NecroFragment.Alt then
	    if NecroChild.NecroDimension.Toggle.Active then
    	    if (NecroRiddle.x >= NecroFragment.x) and (NecroRiddle.x <= (NecroFragment.x + NecroFragment.width)) then
    	        if (NecroRiddle.y >= NecroFragment.y) and (NecroRiddle.y <= (NecroFragment.y + NecroFragment.height)) then
    	            NecroFragment.mouseOver = true;
    	        end
    	    end
	    end
	end
end

function NecroListen:prerender()
    local NecroRiddle = {};
    local NecroFragment = self;

    if NecroChild.NecroDimension.Toggle ~= nil then
        NecroChild.NecroDimension.Toggle.title = Keyboard.getKeyName(tonumber(NecroChild.Toggle));
    end

    if not NecroFragment.Alt then
	    NecroFragment:setStencilRect(0, 0, NecroFragment.width + 1, NecroFragment.height);
	end

	if NecroFragment.Sprite then
	    if NecroFragment.mouseOver and NecroFragment.enable then
		    NecroFragment:drawTexture(NecroFragment.Sprite, 0, 0, 1, 1, 0.1, 0.1);
        else
            NecroFragment:drawTexture(NecroFragment.Sprite, 0, 0, 1, 1, 1, 1);
        end
	else
	    if NecroFragment.mouseOver and NecroFragment.enable then
		    NecroFragment:drawRect(0, 0, NecroFragment.width, NecroFragment.height, 1, 0.3, 0.3, 0.3);
            NecroFragment:drawRectBorder(0, 0, NecroFragment.width, NecroFragment.height, 1, 0.7, 0.7, 0.7);
        else
            NecroFragment:drawRect(0, 0, NecroFragment.width, NecroFragment.height, 1, 0, 0, 0)
            NecroFragment:drawRectBorder(0, 0, NecroFragment.width, NecroFragment.height, 1, 0.7, 0.7, 0.7);
        end
	end
	if NecroFragment.SpriteOver then
	    NecroFragment:drawTexture(NecroFragment.SpriteOver, 0, 0, 1, 1, 1, 1);
	end
	if NecroFragment.title ~= nil then
		NecroRiddle.height = getTextManager():MeasureFont(UIFont.Medium) / 2;
		NecroFragment:drawTextCentre(NecroFragment.title, NecroFragment.width / 2, (NecroFragment.height / 2) - NecroRiddle.height, 1, 1, 1, 1, UIFont.Medium);
    end
    NecroFragment:clearStencilRect();
end

function NecroListen:render()
	local NecroRiddle = {};
	local NecroFragment = self;
  	NecroRiddle.TxTH = NecroChild.height - (19 + 6 + 9) + 2;
    NecroRiddle.TxTM = ((NecroChild.width - (18 + 100 + 8)) / 2) + 9 + 50 + 4;
	if NecroFragment.image ~= nil then
        NecroFragment:drawTexture(NecroFragment.image, NecroFragment.x, NecroFragment.y, 1);
    end
	if not NecroFragment.Alt and NecroFragment.mouseOver then
		NecroChild:setStencilRect(9 + 50 + 4, NecroChild.height - (19 + 6 + 9), NecroChild.width - (18 + 100 + 8), 19);
		NecroChild:drawTextCentre(NecroFragment.tooltip, NecroRiddle.TxTM, NecroRiddle.TxTH, 1, 0.2, 0.2, 1, UIFont.small);
        NecroChild:clearStencilRect();
    end
end

function NecroCipher:instantiate()
	NecroChild.NecroCipher.javaObject = UIElement.new(NecroChild.NecroCipher);
	NecroChild.NecroCipher.javaObject:setX(NecroChild.NecroCipher.x);
	NecroChild.NecroCipher.javaObject:setY(NecroChild.NecroCipher.y);
	NecroChild.NecroCipher.javaObject:setHeight(NecroChild.NecroCipher.height);
	NecroChild.NecroCipher.javaObject:setWidth(NecroChild.NecroCipher.width);
	NecroChild.NecroCipher.javaObject:setAnchorLeft(NecroChild.NecroCipher.anchorLeft);
	NecroChild.NecroCipher.javaObject:setAnchorRight(NecroChild.NecroCipher.anchorRight);
	NecroChild.NecroCipher.javaObject:setAnchorTop(NecroChild.NecroCipher.anchorTop);
	NecroChild.NecroCipher.javaObject:setAnchorBottom(NecroChild.NecroCipher.anchorBottom);
end

function NecroSpeak(NecroRiddleSpeak)
    if not NecroChild.advocate then
        getSoundManager():PlaySound("NecroSpark", false, 0.2);
    end
    NecroChild.NecroListen.AddRem.tooltip = "Add to Favorites";
    NecroChild.NecroListen.AddRem.onclick = NecroVision.Add;
    NecroChild.NecroListen.AddRem.SpriteOver = NecroChild.NecroListen.AddRem.Sprite2;
    NecroChild.NecroCipher:clear();
    for NecroRiddles, NecroRiddlesSpeak in pairs(NecroList.Items) do
    local NecroSpeak = false;
        if NecroRiddleSpeak ~= nil then
            if NecroRiddleSpeak == (NecroRiddlesSpeak[1]) then
                NecroSpeak = true;
            elseif NecroRiddleSpeak == (NecroRiddlesSpeak[2]) then
                NecroSpeak = true;
            elseif NecroRiddleSpeak == (NecroRiddlesSpeak[3]) then
                NecroSpeak = true;
            end
        else
			if (NecroRiddlesSpeak[5]) ~= "NecroForge.NecroFunction" then
				NecroSpeak = true;
			end
        end
        if NecroSpeak then
            if NecroChild.NecroStudy:getText() ~= nil then
                if string.find(string.lower(NecroRiddlesSpeak[4]), string.lower(NecroChild.NecroStudy:getText())) ~= nil then
                    NecroCipher:addItem(NecroRiddles, NecroRiddlesSpeak);
                end
            else
                NecroCipher:addItem(NecroRiddles, NecroRiddlesSpeak);
            end
		end
        if NecroRiddleSpeak == "Favorites" then
            for NecroEchosCount, NecroWhisper in pairs(NecroEchos) do
                if NecroRiddles == NecroWhisper then
                    NecroCipher:addItem(NecroRiddles, NecroRiddlesSpeak);
                end
            end
            NecroChild.NecroListen.AddRem.tooltip = "Remove from Favorites";
            NecroChild.NecroListen.AddRem.onclick = NecroVision.Remove;
            NecroChild.NecroListen.AddRem.SpriteOver = NecroChild.NecroListen.AddRem.Sprite3;
        end
    end
    NecroChild.NecroCipher:sort();
    NecroScanRefresh();
	NecroFlag.ListMin = 0; NecroFlag.ListMax = NecroFlag.ListStep; NecroFlag.ListNum = 1;
	NecroFlag.ListNumMax = math.floor(NecroChild.NecroCipher.count/NecroFlag.ListStep+1)
end

function NecroCipher:onMouseDown(x, y)
	if #NecroChild.NecroCipher.items == 0 then return end
	local NecroRow = self:rowAt(x, y)

	if NecroRow > #NecroChild.NecroCipher.items then
		NecroRow = #NecroChild.NecroCipher.items;
	end
	if NecroRow < 1 then
		NecroRow = 1;
	end
	if NecroFlag.ListMin > 0 then NecroRow = NecroRow + NecroFlag.ListMin - 1 end
	NecroChild.NecroCipher.selected = NecroRow;
	NecroFlag.SelectedItem = NecroRow;

	if NecroChild.NecroCipher.onmousedown then
		NecroChild.NecroCipher.onmousedown(NecroChild.NecroCipher.target, NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].item);
	end
end

function NecroCipher:addItem(NecroRiddles, NecroRiddleSpeak)
    local NecroRiddle = {};
    NecroRiddle.text = NecroRiddleSpeak[4];
    NecroRiddle.item = NecroRiddleSpeak[5];
    NecroRiddle.icon = NecroRiddleSpeak[6];
    NecroRiddle.r = NecroRiddleSpeak[7];
    NecroRiddle.g = NecroRiddleSpeak[8];
    NecroRiddle.b = NecroRiddleSpeak[9];
	NecroRiddle.Function = NecroRiddleSpeak[10];
    NecroRiddle.State = NecroRiddleSpeak[11];
	NecroRiddle.Extra = NecroRiddleSpeak[12];
	NecroRiddle.X = NecroRiddleSpeak[13];
	NecroRiddle.Y = NecroRiddleSpeak[14];
	NecroRiddle.Z = NecroRiddleSpeak[15];
    NecroRiddle.ref = NecroRiddles;
    NecroRiddle.tooltip = nil;
    NecroRiddle.itemindex = NecroChild.NecroCipher.count + 1;
    table.insert(NecroChild.NecroCipher.items, NecroRiddle);
    NecroChild.NecroCipher.count = NecroChild.NecroCipher.count + 1;
    NecroChild.NecroCipher:setScrollHeight(NecroChild.NecroCipher:getScrollHeight() + NecroChild.NecroCipher.itemheight);
end

function NecroCipher:onMouseMoveOutside(x, y)
    NecroVision:ceaseVision();
	NecroChild.NecroCipher.Item = nil
end

function NecroCipher:onMouseMove(x, y)
	local NecroRiddle = {};
	NecroRiddle.item = math.ceil((self:getMouseY() / self.itemheight));
	if NecroFlag.ListMin > 0 then
		NecroRiddle.item = NecroRiddle.item + (NecroFlag.ListMin - 1)
	end
	if NecroRiddle.item > #NecroChild.NecroCipher.items then
		NecroRiddle.item = 0;
	end
    if NecroChild.NecroCipher.Item ~= NecroRiddle.item then
        NecroVision:ceaseVision();
    	if NecroRiddle.item > 0 then
            NecroChild.NecroCipher.Item = NecroRiddle.item;
    	    NecroRiddle.itemObj = InventoryItemFactory.CreateItem(NecroChild.NecroCipher.items[NecroRiddle.item].item);
			if NecroRiddle.itemObj == nil then
				NecroRiddle.itemObj = InventoryItemFactory.CreateItem("NecroForge.NecroError");
				--[[ !!DEBUG!!
				print("[NecroForge] - DEBUG - Error on Module.ItemID - " .. NecroChild.NecroCipher.items[NecroRiddle.item].item .. " - Check NecroList - Item Doesn't Exist")
				--]]
			else
				if NecroChild.NecroCipher.items[NecroRiddle.item].State == "Cooked" then
					NecroRiddle.itemObj:setCooked(true);
				elseif NecroChild.NecroCipher.items[NecroRiddle.item].State == "Burnt" then
					NecroRiddle.itemObj:setBurnt(true);
				elseif NecroChild.NecroCipher.items[NecroRiddle.item].State == "Bad" then
					NecroRiddle.itemObj:setAge(NecroRiddle.itemObj:getOffAge() + 1);
				elseif NecroChild.NecroCipher.items[NecroRiddle.item].State == "Rotten" then
					NecroRiddle.itemObj:setAge(NecroRiddle.itemObj:getOffAgeMax());
				end
			end
			-- Don't Display a Inventory Tooltip when mousing over a Funcion "Item"
			if NecroRiddle.itemObj:getType() ~= "NecroFunction" then
				NecroScry = ISToolTipInv:new(NecroRiddle.itemObj);
				NecroScry:initialise();
				NecroScry:addToUIManager();
				NecroScry:setVisible(true);
			end
			NecroRiddle.itemObj = nil;
    	end
    end
end

function NecroCipher:prerender()
	local NecroFragment = {};
    NecroFragment.index = 1;
	if NecroFlag.ListMin > 0 then  NecroFragment.index = 1 + NecroFlag.ListMin - 1 end;
    NecroFragment.YPos = 0;
	NecroChild.NecroCipher:setStencilRect(1, 2, NecroChild.NecroCipher.width - 2, NecroChild.NecroCipher.height - 3);
	NecroChild.NecroCipher:drawRect(0, 0 - NecroChild.NecroCipher:getYScroll(), NecroChild.NecroCipher.width, NecroChild.NecroCipher.height, 0.2, 0, 0, 0);
	if NecroChild.NecroCipher.items == nil then
		return;
	end
	for NecroRiddleCount, NecroRiddleSpeak in ipairs(NecroChild.NecroCipher.items) do
		if NecroRiddleCount >= NecroFlag.ListMin and NecroRiddleCount < NecroFlag.ListMax then
			if NecroChild.NecroCipher.selected == NecroFragment.index then
				NecroChild.NecroCipher:drawRect(0, NecroFragment.YPos, NecroChild.NecroCipher:getWidth(), NecroChild.NecroCipher.itemheight - 1, 0.3, 0.7, 0.35, 0.15);
			end
			NecroChild.NecroCipher:drawText(NecroRiddleSpeak.text, 25, NecroFragment.YPos + 2, 0.9, 0.9, 0.9, 0.9, UIFont.Medium);
			
			if NecroFlag.Icons then
			NecroFragment.Icon = getTexture(NecroRiddleSpeak.icon);
			if NecroFragment.Icon == nil then
				NecroFragment.Icon = getTexture("media/textures/" .. NecroRiddleSpeak.icon .. ".png");
				if NecroFragment.Icon == nil then
					--[[ !!DEBUG!!
					print("[NecroForge] - DEBUG - Error on Item - " .. NecroRiddleSpeak.text .. " - Check NecroList - Item Has no Icon")
					--]]
					NecroFragment.Icon = getTexture("media/textures/Item_NecroError.png");
				end
			end
			if NecroFragment.Icon:getHeight() > NecroFragment.Icon:getWidth() then
				NecroFragment.Height = 21;
				NecroFragment.Width = math.floor(NecroFragment.Height / (NecroFragment.Icon:getHeight() / NecroFragment.Icon:getWidth()));
			else
				NecroFragment.Width = 21;
				NecroFragment.Height = math.floor(NecroFragment.Width * (NecroFragment.Icon:getHeight() / NecroFragment.Icon:getWidth()));
			end
			NecroFragment.x = NecroChild.NecroCipher.width - 25 - NecroFragment.Width;
			NecroFragment.y = math.floor((NecroFragment.YPos + (NecroChild.NecroCipher.itemheight / 2)) - (NecroFragment.Height / 2));
			
			if NecroRiddleSpeak.r == nil then
				NecroChild.NecroCipher:drawTextureScaled(NecroFragment.Icon, NecroFragment.x, NecroFragment.y, NecroFragment.Width, NecroFragment.Height, 1, 1, 1, 1);
			else
				NecroFragment.r = (NecroRiddleSpeak.r / 255);
				NecroFragment.g = (NecroRiddleSpeak.g / 255);
				NecroFragment.b = (NecroRiddleSpeak.b / 255);
				NecroChild.NecroCipher:drawTextureScaled(NecroFragment.Icon, NecroFragment.x, NecroFragment.y, NecroFragment.Width, NecroFragment.Height, 1, NecroFragment.r, NecroFragment.g, NecroFragment.b);
			end
			end
			NecroFragment.YPos = NecroFragment.YPos + NecroChild.NecroCipher.itemheight;
			NecroFragment.index = NecroFragment.index + 1
		end
	end
	NecroChild.NecroCipher:setScrollHeight(NecroFragment.YPos);
	NecroChild.NecroCipher:clearStencilRect();
end

function NecroCipher:onMouseWheel(del)
    NecroVision:ceaseVision();
    NecroChild.NecroCipher:setYScroll(NecroChild.NecroCipher:getYScroll() - (del*18));
    NecroChild.NecroScanI:updatePos();
    NecroChild.NecroScanII:updatePos();
    return true;
end

function NecroScan:new(parent, vertical)
	local NecroRiddle = {};
	NecroRiddle = ISScrollBar:new(parent, vertical);
	setmetatable(NecroRiddle, self)
	self.__index = self
	NecroRiddle.y = NecroChild.NecroCipher.y;
	NecroRiddle.width = 13;
	NecroRiddle.height = NecroChild.NecroCipher.height;
	return NecroRiddle;
end

function NecroScan:instantiate()
	local NecroRiddle = self;
	NecroRiddle.javaObject = UIElement.new(NecroRiddle);
	NecroRiddle.javaObject:setX(NecroRiddle.x);
	NecroRiddle.javaObject:setY(NecroRiddle.y);
	NecroRiddle.javaObject:setHeight(NecroRiddle.height);
	NecroRiddle.javaObject:setWidth(NecroRiddle.width);
	NecroRiddle.javaObject:setAnchorLeft(NecroRiddle.anchorLeft);
	NecroRiddle.javaObject:setAnchorRight(NecroRiddle.anchorRight);
	NecroRiddle.javaObject:setAnchorTop(NecroRiddle.anchorTop);
	NecroRiddle.javaObject:setAnchorBottom(NecroRiddle.anchorBottom);
    NecroRiddle.javaObject:setScrollWithParent(false);
    self = NecroRiddle;
end

function NecroVision:ceaseVision()
    if NecroScry then
        NecroScry:setVisible(false);
        NecroScry:removeFromUIManager();
        NecroScry = nil;
    end
end

function NecroScan:onMouseDown(x, y)
	local NecroRiddle = self;
	NecroRiddle.scrolling = false;
    NecroVision:ceaseVision();
	if (x >= NecroRiddle.barx and x <= NecroRiddle.barx + NecroRiddle.barwidth) then
		if (y >= NecroRiddle.bary and y <= NecroRiddle.bary + NecroRiddle.barheight) then
			NecroRiddle.scrolling = true;
		end
	end
	self = NecroRiddle;
end

function NecroScan:onMouseMove(dx, dy)
	local NecroRiddle = self;
	if NecroRiddle.scrolling then
		if NecroChild.NecroCipher:getScrollHeight() > NecroRiddle.height then
            NecroRiddle.scanI = (NecroRiddle.height / NecroChild.NecroCipher:getScrollHeight()) * (NecroRiddle.height - (20 * 2))
       		NecroRiddle.scanII = NecroRiddle.height - (20 * 2) - NecroRiddle.scanI;
    		NecroRiddle.pos = NecroRiddle.pos + (dy / NecroRiddle.scanII);
    		if NecroRiddle.pos < 0 then
    			NecroRiddle.pos = 0;
    		end
    		if NecroRiddle.pos > 1 then
    			NecroRiddle.pos = 1;
    		end
    		NecroChild.NecroCipher:setYScroll(0 - (NecroRiddle.pos * (NecroChild.NecroCipher:getScrollHeight() - NecroRiddle.height)));
            if NecroRiddle.Truth then
                NecroChild.NecroScanII:updatePos()
            else
                NecroChild.NecroScanI:updatePos()
            end
		end
	end
	self = NecroRiddle;
end

function NecroScan:render()
    local NecroRiddle = self;
	if NecroChild.NecroCipher:getScrollHeight() > NecroRiddle.height then
        NecroRiddle.scanI = (NecroRiddle.height / NecroChild.NecroCipher:getScrollHeight()) * (NecroRiddle.height - (16 * 2))
		NecroRiddle.scanII = NecroRiddle.height - (16 * 2) - NecroRiddle.scanI;
		NecroRiddle.scanII = NecroRiddle.scanII * NecroRiddle.pos;
		NecroRiddle.barx = 4;
		NecroRiddle.bary = 16 + NecroRiddle.scanII;
		NecroRiddle.barwidth = 8;
		NecroRiddle.barheight = NecroRiddle.scanI;
        NecroRiddle:setStencilRect(0, 0, NecroRiddle.width, NecroRiddle.height);
        NecroRiddle:drawTexture(NecroRiddle.uptex, 1, 0, 1, 1, 1, 1);
        NecroRiddle:drawTexture(NecroRiddle.downtex, 1, NecroRiddle.height - 20, 1, 1, 1, 1);
        NecroRiddle:drawTextureScaled(NecroRiddle.midtex, 2, NecroRiddle.bary + 2, 9, NecroRiddle.barheight - 4, 1, 1, 1, 1);
        NecroRiddle:drawTexture(NecroRiddle.toptex, 2, NecroRiddle.bary, 1, 1, 1, 1);
        NecroRiddle:drawTexture(NecroRiddle.bottex, 2, (NecroRiddle.bary + NecroRiddle.barheight)-3, 1, 1, 1, 1);
        NecroRiddle:drawRectBorder(0, 0, NecroRiddle.width, NecroRiddle.height, 1, 0.4, 0.4, 0.4);
        NecroRiddle:clearStencilRect();
    else
	    NecroRiddle.barx = 0;
		NecroRiddle.bary = 0;
		NecroRiddle.barwidth = 0;
		NecroRiddle.barheight = 0;
	end
    self = NecroRiddle;
end

----------------------------------------------
--					  						--
--			 Check if Function/Item			--
--					   						--
----------------------------------------------

-- Begin Execution
function NecroVision:NecroExecute()
	if NecroVision.AdminCheck() then
		local NecroFunction = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].Function
		if NecroFunction then
			NecroVision.ExecuteFunction()
			getSoundManager():PlaySound("NecroForge", false, 0.8);
		else
			if NecroFlag.Brush and NecroFlag.BrushType == "Item Spawner" then
				if NecroFlag.Info then
					getSpecificPlayer(0):Say("Item Spawner Brush is Enabled")
				end
			else
				NecroVision.Spawn()
				getSoundManager():PlaySound("NecroForge", false, 0.8);
			end
		end
	end
end

----------------------------------------------
--					  						--
--			   	 Item Spawner				--
--					   						--
----------------------------------------------

-- Execute Spawn Items
function NecroVision:Spawn()
	-- Begin Local Variables
	local Necropl = getSpecificPlayer(0)
	local NecroFunctionItem = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].item
	local NecroFunctionState = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].State
	local NecroFunctionR = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].r
	local NecroFunctionG = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].g
	local NecroFunctionB = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].b
	-- End Local Variables
    if NecroFunctionR == nil then
        if NecroFunctionState == "Cooked" then
			if NecroFlag.Ground then
				local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					NecroGroundItem:setCooked(true);
					Necropl:getSquare():AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
			else
				for i = 1,NecroFlag.Count do 
				NecroMorph = NecroChild.NecroListen.Spawn.Damned:AddItem(NecroFunctionItem);
				NecroMorph:setCooked(true);
			end
		end
        elseif NecroFunctionState == "Burnt" then
			if NecroFlag.Ground then
				local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					NecroGroundItem:setBurnt(true);
					Necropl:getSquare():AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
			else
				for i = 1,NecroFlag.Count do 
				NecroMorph = NecroChild.NecroListen.Spawn.Damned:AddItem(NecroFunctionItem);
				NecroMorph:setBurnt(true);
				end
			end

        elseif NecroFunctionState == "Bad" then
			if NecroFlag.Ground then
				local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					NecroGroundItem:setAge(NecroGroundItem:getOffAge() + 1);
					Necropl:getSquare():AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
			else
				for i = 1,NecroFlag.Count do 
				NecroMorph = NecroChild.NecroListen.Spawn.Damned:AddItem(NecroFunctionItem);
				NecroMorph:setAge(NecroMorph:getOffAge() + 1);
				end
			end
        elseif NecroFunctionState == "Rotten" then
			if NecroFlag.Ground then
				local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					NecroGroundItem:setAge(NecroGroundItem:getOffAgeMax());
					Necropl:getSquare():AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
			else
				for i = 1,NecroFlag.Count do 
				NecroMorph = NecroChild.NecroListen.Spawn.Damned:AddItem(NecroFunctionItem);
				NecroMorph:setAge(NecroMorph:getOffAgeMax());
				end
			end
        else
			if NecroFlag.Ground then
				local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
				Necropl:getSquare():AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
			else
				NecroChild.NecroListen.Spawn.Damned:AddItems(NecroFunctionItem,(NecroFlag.Count));
			end
		end
		else
        local NecroRags = nil;
        local NecroRagsHue = nil;
        local NecroRagsHueI = nil;
        local NecroRagsHueII = nil;
        local NecroRagsHueIII = nil;
        NecroRagsHueI = ((NecroFunctionR) / 255);
        NecroRagsHueII = ((NecroFunctionG) / 255);
        NecroRagsHueIII = ((NecroFunctionB) / 255);
        NecroRagsHue = ColorInfo.new(NecroRagsHueI, NecroRagsHueII, NecroRagsHueIII, 1);
		if NecroFlag.Ground then
			local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
			NecroGroundItem:setColor(NecroRagsHue:toColor());
			Necropl:getSquare():AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
			else
			for i = 1,NecroFlag.Count do 
				NecroRags = NecroChild.NecroListen.Spawn.Damned:AddItem(NecroFunctionItem);
				NecroRags:setColor(NecroRagsHue:toColor());
			end
		end
	end
end

----------------------------------------------
--					  						--
--			  Function Execution			--
--					   						--
----------------------------------------------

-- Execute Functions
function NecroVision:ExecuteFunction()
	local Necropl = getSpecificPlayer(0)
	local Necrost = getSpecificPlayer(0):getStats()
	local Necrobd = getSpecificPlayer(0):getBodyDamage()
	local Necroxp = getSpecificPlayer(0):getXp()
	local NecroFunctionState = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].State
	local NecroFunctionExtra = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].Extra
	local NecroFunctionX = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].X
	local NecroFunctionY = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].Y
	local NecroFunctionZ = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].Z
	-- Function Change Spawn Amount
	if NecroFunctionState == "NecroCounter" then
		NecroFlag.Count = NecroFunctionExtra;
			if NecroFlag.Info then
				Necropl:Say("Spawn Amount = " .. NecroFlag.Count);
			end
	-- Function Toggle Spawning on the Ground
	elseif NecroFunctionState == "GroundSpawnToggle" then
		if NecroFlag.Ground then
			NecroFlag.Ground = false;
			if NecroFlag.Info then
				Necropl:Say("Ground Spawn Disabled");
			end
		else
			NecroFlag.Ground = true;
			if NecroFlag.Info then
				Necropl:Say("Ground Spawn Enabled");
			end
		end
	-- Function Attract Zombies
	elseif NecroFunctionState == "ZombieAttract" then
		local NecroticAttraction = NecroFunctionExtra;
		addSound(Necropl, Necropl:getX(), Necropl:getY(), Necropl:getZ(), NecroticAttraction, NecroticAttraction);
		if NecroFlag.Info then
			Necropl:Say("Attracting Zombies");
		end
	-- Function Spawn Zombie [Old Method - Replaced by Brush Method - Mostly Here for MP Command]
	elseif NecroFunctionState == "Zombie" then
		if isClient() then
			SendCommandToServer("/createhorde " .. NecroFlag.Count .. " " .. Necropl:getDisplayName());
		else
			for i = 1, NecroFlag.Count do
				spawnHorde(getSpecificPlayer(0):getX(), getSpecificPlayer(0):getY() - 5, getSpecificPlayer(0):getX(), getSpecificPlayer(0):getY() - 5, getSpecificPlayer(0):getZ(), (NecroFlag.Count));
			end
		end
	-- Function Toggle Weight Limit
	elseif NecroFunctionState == "WeightLimit" then
		if NecroFlag.Weight then
			Necropl:setMaxWeightBase(8);
			NecroFlag.Weight = false;
			if NecroFlag.Info then
				Necropl:Say("Weight Limit Enabled");
			end
		else
			Necropl:setMaxWeightBase(60000);
			NecroFlag.Weight = true;
			if NecroFlag.Info then
				Necropl:Say("Weight Limit Disabled");
			end
		end
	-- Function Toggle Text Pop-Ups
	elseif NecroFunctionState == "NecroInformant" then
		if NecroFlag.Info then
			NecroFlag.Info = false;
			Necropl:Say("Text PopUps Disabled");
		else
			NecroFlag.Info = true;
			Necropl:Say("Text PopUps Enabled");
		end
	-- Function Toggle UI Item Icons
	elseif NecroFunctionState == "NecroGraphics" then
		if NecroFlag.Icons then
			NecroFlag.Icons = false;
			Necropl:Say("UI Item Icons Disabled");
		else
			NecroFlag.Icons = true;
			Necropl:Say("UI Item Icons Enabled");
		end
	-- Function Remove Moveable
	elseif NecroFunctionState == "MoveableRemove" then
		Necropl:getInventory():Remove("Moveable");
	-- Function Toggle Debug Info
	elseif NecroFunctionState == "NecroDebugger" then
		if NecroFlag.Debug then
			NecroFlag.Debug = false;
			if NecroFlag.Info then
			Necropl:Say("Debug Info Disabled");
			end
		else
			NecroFlag.Debug = true;
			if NecroFlag.Info then
			Necropl:Say("Debug Info Enabled");
			end
		end
	-- Function Toggle Health Reset
	elseif NecroFunctionState == "HealMe" then
		Necrobd:RestoreToFullHealth();
		if NecroFlag.Info then
			Necropl:Say("Health Restored");
		end
	-- Function Toggle Build Mode
	elseif NecroFunctionState == "Creative" then
		if ISBuildMenu.cheat then
			ISBuildMenu.cheat = false;
			NecroFlag.Build = false;
			if NecroFlag.Info then
				Necropl:Say("Build Mode Disabled");
			end
		else
			ISBuildMenu.cheat = true;
			NecroFlag.Build = true;
			if NecroFlag.Info then
				Necropl:Say("Build Mode Enabled");
			end
		end
	-- Function Toggle Farmer Mode
	elseif NecroFunctionState == "Farmer" then
		if ISFarmingMenu.cheat then
			ISFarmingMenu.cheat = false;
			NecroFlag.Farm = false;
			if NecroFlag.Info then
				Necropl:Say("Farming Debug Disabled");
			end
		else
			ISFarmingMenu.cheat = true;
			NecroFlag.Farm = true;
			if NecroFlag.Info then
				Necropl:Say("Farming Debug Enabled");
			end
		end
	-- Function Toggle Medic Mode
	elseif NecroFunctionState == "Medic" then
		if ISHealthPanel.cheat then
			ISHealthPanel.cheat = false;
			if NecroFlag.Info then
				Necropl:Say("Health Debug Disabled");
			end
		else
			ISHealthPanel.cheat = true;
			if NecroFlag.Info then
				Necropl:Say("Health Debug Enabled");
			end
		end
	-- Function Toggle Ghost Mode
	elseif NecroFunctionState == "Ghost" then
		if getSpecificPlayer(0):isGhostMode() then
			getSpecificPlayer(0):setGhostMode(false)
			NecroFlag.Ghost = false;
			if NecroFlag.Info then
				Necropl:Say("Ghost Mode Disabled");
			end
		else
			getSpecificPlayer(0):setGhostMode(true)
			NecroFlag.Ghost = true;
			if NecroFlag.Info then
				Necropl:Say("Ghost Mode Enabled");
			end
		end
	-- Toggle Noclip Mode
	elseif NecroFunctionState == "Noclip" then
		if getSpecificPlayer(0):isNoClip() then
			getSpecificPlayer(0):setNoClip(false)
			NecroFlag.Noclip = false;
			if NecroFlag.Info then
				Necropl:Say("Noclip Mode Disabled");
			end
		else
			getSpecificPlayer(0):setNoClip(true)
			NecroFlag.Noclip = true;
			if NecroFlag.Info then
				Necropl:Say("Noclip Mode Enabled");
			end
		end
	elseif NecroFunctionState == "Flight" then
		if NecroFlag.Flight then
			Necropl:setZ(0);
			NecroFlag.Flight = false;
			if NecroFlag.Info then
				Necropl:Say("Flight Mode Disabled");
			end
		else
			NecroFlag.Z = Necropl:getZ()
			NecroFlag.Flight = true;
			if NecroFlag.Info then
				Necropl:Say("Flight Mode Enabled");
				Necropl:Say("Use PageUp/PageDown to Control Height");
			end
		end
	-- Function Reset Stats
	elseif NecroFunctionState == "Stats" then
		Necrobd:setBoredomLevel(0);
		Necrost:setFatigue(0);
		Necrost:setHunger(0);
		Necrost:setThirst(0);
		Necrost:setAnger(0);
		Necrost:setPain(0);
		Necrost:setStress(0);
		Necrost:setStressFromCigarettes(0);
		Necrost:setPanic(0);
		Necrost:setDrunkenness(0);
		Necrost:setSickness(0);
		Necrost:setSanity(1);
		Necrost:setEndurance(1);
		Necrobd:setTemperature(30);
		Necrobd:setWetness(0);
		Necrobd:setUnhappynessLevel(0);
		Necropl:setTimeSinceLastSmoke(0);
		if NecroFlag.Info then
			Necropl:Say("All Stats Reset");
		end
	-- Function Reset Nutrition
	elseif NecroFunctionState == "Weight" then
		Necropl:getNutrition():setWeight(80);
		if NecroFlag.Info then
			Necropl:Say("Weight Reset");
		end
	-- Function Freeze Stats
	elseif NecroFunctionState == "FreezeStats" then
		if NecroFlag.God then
			if NecroFlag.Info then
				Necropl:Say("God Mode Disabled");
			end
			NecroFlag.God = false;
		else
			if NecroFlag.Info then
				Necropl:Say("God Mode Enabled");
			end
			NecroFlag.God = true;
		end
	-- Function Level Up Skills
	elseif NecroFunctionState == "ExpAll" then
	local 	NecroPerks = {Perks.Axe, Perks.Strength, Perks.Cooking, Perks.Doctor, Perks.Aiming, Perks.Reloading, Perks.Fishing, Perks.PlantScavenging, Perks.Farming,
			Perks.Woodwork, Perks.Nimble, Perks.Sneak, Perks.Lightfoot, Perks.Blunt, Perks.Sprinting, Perks.Fitness, Perks.Trapping, Perks.BladeGuard, Perks.BluntGuard,
			Perks.Electricity, Perks.BladeMaintenance, Perks.BluntMaintenance, Perks.MetalWelding, Perks.Mechanics}
			for i = 1, #NecroPerks do
				local NecroPerk = NecroPerks[i]
				Necropl:LevelPerk(NecroPerk);
				luautils.updatePerksXp(NecroPerk, Necropl)
			end
		if NecroFlag.Info then
			Necropl:Say("Skills Leveled Up");
		end
	-- Function Level Up Individual Skill
	elseif NecroFunctionState == "Exp" then
		Necropl:LevelPerk(NecroFunctionExtra);
		luautils.updatePerksXp(NecroFunctionExtra, Necropl)
		if NecroFlag.Info then
		Necropl:Say("Skill Leveled Up");
		end
	-- Function Time Control
	elseif NecroFunctionState == "NecroChronos" then
		if NecroFunctionX == "Single" and isClient() == true then
			if NecroFlag.Info then
				Necropl:Say("Not Available in Multi Player")
			end
		else
		local NecroChronos = getGameTime()
		local NecroChronosDone = true;
		if NecroFunctionExtra == "Hour" then
			NecroChronos:setTimeOfDay(NecroChronos:getTimeOfDay() + 1)
		elseif NecroFunctionExtra == "Day" then
			if NecroChronos:getDay() < 30 then
				NecroChronos:setDay(NecroChronos:getDay() + 1)
			else
				NecroChronosDone = false;
			end
		elseif NecroFunctionExtra == "Month" then
			if NecroChronos:getMonth() < 11 then
				NecroChronos:setMonth(NecroChronos:getMonth() + 1)
			else
				NecroChronosDone = false;
			end
		end
		if NecroFlag.Info then
			if NecroChronosDone then
				Necropl:Say("Time Moved Forward");
			else
				Necropl:Say("Cannot Add Further");
			end
		end
		end
	-- Function Add Trait
	elseif NecroFunctionState == "Trait" then
		Necropl:getTraits():add(NecroFunctionExtra);
			if NecroFlag.Info then
				Necropl:Say("Trait Added");
			end
	-- Function Toggle Brushes
	elseif NecroFunctionState == "Brush" then
		getCell():setDrag(nil, Necropl:getPlayerNum());
		if NecroFunctionX == "Single" and isClient() == true then
			if NecroFlag.Info then
				Necropl:Say("Not Available in Multi Player")
			end
		else
		local BrushToggle = true;
		-- Enable/Disable Individual Brushes -- Allow Only One Brush at a Time --
		if NecroFlag.Brush and NecroFlag.BrushType == NecroFunctionExtra and NecroFlag.BrushSpec == NecroFunctionY then
			NecroFlag.Brush = false;
			BrushToggle = false;
		else
			NecroFlag.Brush = true;
			NecroFlag.BrushType = NecroFunctionExtra;
			NecroFlag.BrushSpec = NecroFunctionY;
		end
		if NecroFlag.Info then
			if BrushToggle then
				Necropl:Say(NecroFunctionExtra .. " Brush Enabled");
				if NecroFlag.BrushType == "Tile/Object Clone" then
					Necropl:Say("Press \"R\" to Select Highlighted [Red] Object")
					Necropl:Say("Click to Place Selected Object")
				elseif NecroFlag.BrushType == "Barricade" then
					Necropl:Say("Press \"R\" to Change Barricade Type")
				elseif NecroFlag.BrushType == "Place Floor" then
					Necropl:Say("Press \"R\" to Toggle Forced Tile Replacement")
				elseif NecroFlag.BrushType == "Keymaker" then
					Necropl:Say("Click on Tile with a Door to get a Key")
				elseif NecroFlag.BrushType == "Item Spawner" then
					Necropl:Say("Select Item in the UI and Click to Spawn")
				elseif NecroFlag.BrushType == "Lockmaker" then
					Necropl:Say("Press \"R\" to Pick a Lock ID from Highlighted Door")
					Necropl:Say("Press \"F\" to Generate Random Lock ID")
				end
			else
				Necropl:Say(NecroFunctionExtra .. " Brush Disabled");
			end
		end
		end
	-- Rain Start/Stop
	elseif NecroFunctionState == "Rain" then
		if RainManager.isRaining() then
			RainManager.stopRaining();
			if NecroFlag.Info then
				Necropl:Say("Rain is Stopping");
			end
		else
			RainManager.setRandRainMax((ZombRand(10) + 25));
			RainManager.setRandRainMin(ZombRand(5));
			RainManager.startRaining();
			if NecroFlag.Info then
				Necropl:Say("Rain is Starting");
			end
		end
	-- Function Change Music
	elseif NecroFunctionState == "Music" then
		getSoundManager():StopMusic();
		local Necrobeats = tostring(NecroFunctionExtra);
		getSoundManager():playMusic(Necrobeats);
			if NecroFlag.Info then
				Necropl:Say("Music Track Changed");
			end
	-- Function Stop Music
	elseif NecroFunctionState == "MusicStop" then
		getSoundManager():StopMusic();
			if NecroFlag.Info then
				Necropl:Say("Music Stopped");
			end
	-- Function Preset Teleportation
	elseif NecroFunctionState == "Teleport" then
		-- Prevent Teleportation if Player is in a Vehicle
		if NecroVision.VehicleBuildTester() and NecroVision.VehicleTester() then
			if NecroFlag.Info then
				Necropl:Say("Not While in a Vehicle");
			end
		else 
			Necropl:setX(NecroFunctionX);
			Necropl:setY(NecroFunctionY);
			Necropl:setZ(NecroFunctionZ);
			Necropl:setLx(NecroFunctionX);
			Necropl:setLy(NecroFunctionY);
			Necropl:setLz(NecroFunctionZ);
		end
	-- Vehicle Functions
	elseif NecroFunctionState == "Vehicle" then
		if NecroVision.VehicleBuildTester() then
			NecroVision.NecroMobile();
		else
			if NecroFlag.Info then
				Necropl:Say("This Build Doesn't Have Vehicles in It");
			end
		end
	-- Function Spawn Random Vehicle
	elseif NecroFunctionState == "VehicleSpawn" then
		if isClient() then
			if NecroFlag.Info then
				Necropl:Say("Not Available in MultiPlayer");
			end
		else
			if NecroVision.VehicleBuildTester() then
				if NecroVision.VehicleTester() then
					if NecroFlag.Info then
						Necropl:Say("Not While in a Vehicle");
					end
				else
					addVehicle()
				end
			else
				if NecroFlag.Info then
					Necropl:Say("This Build Doesn't Have Vehicles in It");
				end
			end
		end
	end
	NecroVision:FunctionWarnCheck()
end

----------------------------------------------
--					  						--
--			  Vehicular Functions			--
--					   						--
----------------------------------------------

function NecroVision:NecroMobile()
	local Necropl = getSpecificPlayer(0)
	local NecroFunctionExtra = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].Extra
	local NecroFunctionX = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].X
	-- Get Vehicle the Player is in.
	local Necroveh = Necropl:getVehicle()
	-- Player is not in a Vehicle -- Attempt to Find a Vehicle Near the Player
	if Necroveh == nil then
	local Necrosx = Necropl:getX()
	local Necrosy = Necropl:getY()
	local Necrosz = Necropl:getZ()
	local Necrosqs = {}
	Necrosqs[1] = getCell():getGridSquare(Necrosx, Necrosy, Necrosz)
	local Necrodir = Necropl:getDir()
	if (Necrodir == IsoDirections.N) then        Necrosqs[2] = getCell():getGridSquare(Necrosx-1, Necrosy-1, Necrosz); Necrosqs[3] = getCell():getGridSquare(Necrosx, Necrosy-1, Necrosz);   Necrosqs[4] = getCell():getGridSquare(Necrosx+1, Necrosy-1, Necrosz);
		elseif (Necrodir == IsoDirections.NE) then   Necrosqs[2] = getCell():getGridSquare(Necrosx, Necrosy-1, Necrosz);   Necrosqs[3] = getCell():getGridSquare(Necrosx+1, Necrosy-1, Necrosz); Necrosqs[4] = getCell():getGridSquare(Necrosx+1, Necrosy, Necrosz);
		elseif (Necrodir == IsoDirections.E) then    Necrosqs[2] = getCell():getGridSquare(Necrosx+1, Necrosy-1, Necrosz); Necrosqs[3] = getCell():getGridSquare(Necrosx+1, Necrosy, Necrosz);   Necrosqs[4] = getCell():getGridSquare(Necrosx+1, Necrosy+1, Necrosz);
		elseif (Necrodir == IsoDirections.SE) then   Necrosqs[2] = getCell():getGridSquare(Necrosx+1, Necrosy, Necrosz);   Necrosqs[3] = getCell():getGridSquare(Necrosx+1, Necrosy+1, Necrosz); Necrosqs[4] = getCell():getGridSquare(Necrosx, Necrosy+1, Necrosz);
		elseif (Necrodir == IsoDirections.S) then    Necrosqs[2] = getCell():getGridSquare(Necrosx+1, Necrosy+1, Necrosz); Necrosqs[3] = getCell():getGridSquare(Necrosx, Necrosy+1, Necrosz);   Necrosqs[4] = getCell():getGridSquare(Necrosx-1, Necrosy+1, Necrosz);
		elseif (Necrodir == IsoDirections.SW) then   Necrosqs[2] = getCell():getGridSquare(Necrosx, Necrosy+1, Necrosz);   Necrosqs[3] = getCell():getGridSquare(Necrosx-1, Necrosy+1, Necrosz); Necrosqs[4] = getCell():getGridSquare(Necrosx-1, Necrosy, Necrosz);
		elseif (Necrodir == IsoDirections.W) then    Necrosqs[2] = getCell():getGridSquare(Necrosx-1, Necrosy+1, Necrosz); Necrosqs[3] = getCell():getGridSquare(Necrosx-1, Necrosy, Necrosz);   Necrosqs[4] = getCell():getGridSquare(Necrosx-1, Necrosy-1, Necrosz);
		elseif (Necrodir == IsoDirections.NW) then   Necrosqs[2] = getCell():getGridSquare(Necrosx-1, Necrosy, Necrosz);   Necrosqs[3] = getCell():getGridSquare(Necrosx-1, Necrosy-1, Necrosz); Necrosqs[4] = getCell():getGridSquare(Necrosx, Necrosy-1, Necrosz);
	end
	for _,Necrosq in ipairs(Necrosqs) do
		Necroveh = Necrosq:getVehicleContainer()
	end
	end
	-- Failed to Find Vehicle -- Notify Player
	if NecroFlag.Info and Necroveh == nil then
		Necropl:Say("No Vehicle Found");
	end
	-- Vehicle Found -- Execute Vehicle Functions
	if Necroveh then
		if NecroFunctionExtra == "VehicleSwap" then
			if isClient() then
				Necropl:Say("Not Available in MultiPlayer")
			else
				Necroveh:setScriptName(NecroFunctionX);
				Necroveh:scriptReloaded();
			end
		elseif NecroFunctionExtra == "VehicleEngineFix" then
			Necroveh:setEngineFeature(100,30);
		elseif NecroFunctionExtra == "VehicleRefuel" then
			local GasTank = Necroveh:getPartById("GasTank");
			if GasTank then GasTank:setContainerContentAmount(GasTank:getContainerCapacity()) end
		elseif NecroFunctionExtra == "VehicleUnlock" then
			local DoorFrontLeft = Necroveh:getPartById("DoorFrontLeft");
			local DoorFrontRight = Necroveh:getPartById("DoorFrontRight");
			local DoorRearLeft = Necroveh:getPartById("DoorRearLeft");
			local DoorRearRight = Necroveh:getPartById("DoorRearRight");
			if DoorFrontLeft then DoorFrontLeft:getDoor():setLocked(false); DoorFrontLeft:getDoor():setLockBroken(false) end
			if DoorFrontRight then DoorFrontRight:getDoor():setLocked(false); DoorFrontRight:getDoor():setLockBroken(false) end
			if DoorRearLeft then DoorRearLeft:getDoor():setLocked(false); DoorRearLeft:getDoor():setLockBroken(false) end
			if DoorRearRight then DoorRearRight:getDoor():setLocked(false); DoorRearRight:getDoor():setLockBroken(false) end
		elseif NecroFunctionExtra == "VehicleLock" then
			local DoorFrontLeft = Necroveh:getPartById("DoorFrontLeft");
			local DoorFrontRight = Necroveh:getPartById("DoorFrontRight");
			local DoorRearLeft = Necroveh:getPartById("DoorRearLeft");
			local DoorRearRight = Necroveh:getPartById("DoorRearRight");
			if DoorFrontLeft then DoorFrontLeft:getDoor():setLocked(true); DoorFrontLeft:getDoor():setLockBroken(false) end
			if DoorFrontRight then DoorFrontRight:getDoor():setLocked(true); DoorFrontRight:getDoor():setLockBroken(false) end
			if DoorRearLeft then DoorRearLeft:getDoor():setLocked(true); DoorRearLeft:getDoor():setLockBroken(false) end
			if DoorRearRight then DoorRearRight:getDoor():setLocked(true); DoorRearRight:getDoor():setLockBroken(false) end
		elseif NecroFunctionExtra == "VehicleKey" then
			local KeyID = Necroveh:getKeyId()
			local KeyItem = InventoryItemFactory.CreateItem("Base.Key"..ZombRandBetween(1,5));
			KeyItem:setKeyId(KeyID);
			KeyItem:setName("Car Key");
			Necropl:getInventory():AddItem(KeyItem);
		elseif NecroFunctionExtra == "VehicleSkinNext" then
			if isClient() then
				Necropl:Say("Not Available in MultiPlayer")
			else
				local SkinIndex = Necroveh:getSkinIndex()
				Necroveh:setSkinIndex(SkinIndex + 1)
				Necroveh:scriptReloaded();
			end
		elseif NecroFunctionExtra == "VehicleSkinPrev" then
			if isClient() then
				Necropl:Say("Not Available in MultiPlayer")
			else
				local SkinIndex = Necroveh:getSkinIndex()
				Necroveh:setSkinIndex(SkinIndex - 1)
				Necroveh:scriptReloaded();
			end
		elseif NecroFunctionExtra == "VehicleReload" then
			Necroveh:scriptReloaded();
		-- Complete Repairs to all Installed Parts
		elseif NecroFunctionExtra == "VehicleFullRepair" then
			-- Get Installed Parts
			local Door1 = Necroveh:getPartById("DoorFrontLeft");
			local Door2 = Necroveh:getPartById("DoorFrontRight");
			local Door3 = Necroveh:getPartById("DoorRearLeft");
			local Door4 = Necroveh:getPartById("DoorRearRight");
			local Tire1 = Necroveh:getPartById("TireFrontLeft");
			local Tire2 = Necroveh:getPartById("TireFrontRight");
			local Tire3 = Necroveh:getPartById("TireRearLeft");
			local Tire4 = Necroveh:getPartById("TireRearRight");
			local Brake1 = Necroveh:getPartById("BrakeFrontLeft");
			local Brake2 = Necroveh:getPartById("BrakeFrontRight");
			local Brake3 = Necroveh:getPartById("BrakeRearLeft");
			local Brake4 = Necroveh:getPartById("BrakeRearRight");
			local Suspension1 = Necroveh:getPartById("SuspensionFrontLeft");
			local Suspension2 = Necroveh:getPartById("SuspensionFrontRight");
			local Suspension3 = Necroveh:getPartById("SuspensionRearLeft");
			local Suspension4 = Necroveh:getPartById("SuspensionRearRight");
			local Window1 = Necroveh:getPartById("WindowFrontLeft");
			local Window2 = Necroveh:getPartById("WindowFrontRight");
			local Window3 = Necroveh:getPartById("WindowRearLeft");
			local Window4 = Necroveh:getPartById("WindowRearRight");
			local Window5 = Necroveh:getPartById("WindshieldRear");
			local Window6 = Necroveh:getPartById("Windshield");
			local Light1 = Necroveh:getPartById("HeadlightLeft");
			local Light2 = Necroveh:getPartById("HeadlightRight");
			local Light3 = Necroveh:getPartById("HeadlightRearLeft");
			local Light4 = Necroveh:getPartById("HeadlightRearRight");
			local Seat1 = Necroveh:getPartById("SeatFrontLeft");
			local Seat2 = Necroveh:getPartById("SeatFrontRight");
			local Seat3 = Necroveh:getPartById("SeatMiddleLeft");
			local Seat4 = Necroveh:getPartById("SeatMiddleRight");
			local Seat5 = Necroveh:getPartById("SeatRearLeft");
			local Seat6 = Necroveh:getPartById("SeatRearRight");
			local GasTank = Necroveh:getPartById("GasTank");
			local Trunk = Necroveh:getPartById("TruckBed");
			local TrunkLid = Necroveh:getPartById("TrunkDoor");
			local Muffler = Necroveh:getPartById("Muffler");
			local Battery = Necroveh:getPartById("Battery");
			local Engine = Necroveh:getPartById("Engine");
			local Radio = Necroveh:getPartById("Radio");
			local GloveBox = Necroveh:getPartById("GloveBox");
			local Hood = Necroveh:getPartById("EngineDoor");
			local Heater = Necroveh:getPartById("Heater");
			local VehicleParts = {Door1, Door2, Door3, Door4 , Tire1, Tire2, Tire3, Tire4, Brake1, Brake2, Brake3, Brake4, Suspension1, Suspension2, Suspension3, Suspension4, Window1, Window2, Window3, Window4, Window5, Window6, Light1, Light2, Light3, Light4, Seat1, Seat2, Seat3, Seat4, Seat5, Seat6, GasTank, Trunk, TrunkLid, Muffler, Battery, Engine, Radio, GloveBox, Hood, Heater}
			-- Fix Found parts
			for i = 1, #VehicleParts do 
				local Part = VehicleParts[i]
				if Part ~= nil then Part:setCondition(100) end
			end
			if NecroFlag.Info then
				Necropl:Say("Installed Parts Repaired");
			end
		end
	end
end

----------------------------------------------
--					  						--
--			   Primary UI Buttons			--
--					   						--
----------------------------------------------

-- Execute Spawn by Module.ItemID
function NecroVision:AnyForge()
	if NecroVision.AdminCheck() then
		getSoundManager():PlaySound("NecroForge", false, 0.8);
		local Necropl = getSpecificPlayer(0)
		local Necroitem = InventoryItemFactory.CreateItem(NecroChild.NecroBlueprint:getText());
		if Necroitem ~= nil then
			if NecroFlag.Ground then
				Necropl:getSquare():AddWorldInventoryItem(Necroitem, 0, 0, 0);
			else
				NecroChild.NecroListen.AnyForge.Creation:AddItems((Necroitem),(NecroFlag.Count));
			end
		else
			-- Tell the Player Item Doesn't Exist
			if NecroFlag.Info then
				Necropl:Say("No Such Item");
			end
		end
	end
end

-- Execute Remove by Module.ItemID
function NecroVision:AnyRemove()
	if NecroVision.AdminCheck() then
		getSoundManager():PlaySound("NecroForge", false, 0.8);
		local Necropl = getSpecificPlayer(0)
		local Necroitem = InventoryItemFactory.CreateItem(NecroChild.NecroBlueprint:getText());
		if Necroitem ~= nil then
			for i = 1,NecroFlag.Count do 
				NecroChild.NecroListen.AnyForge.Creation:Remove(Necroitem:getType());
			end
		else
			-- Tell the Player Item Doesn't Exist
			if NecroFlag.Info then
				Necropl:Say("No Such Item");
			end
		end
	end
end

-- Execute Teleport to Coordinates
function NecroVision:GotoCoord()
	if NecroVision.AdminCheck() then
	getSoundManager():PlaySound("NecroForge", false, 0.8);
	local Necropl = getSpecificPlayer(0)
	local Necrox = tonumber(NecroChild.NecroCartographyX:getText())
	local Necroy = tonumber(NecroChild.NecroCartographyY:getText())
	local Necroz = tonumber(NecroChild.NecroCartographyZ:getText())
	-- Prevent Teleportation if Coordinates are Missing or Player is in a Vehicle
		if NecroVision.VehicleBuildTester() and NecroVision.VehicleTester() then
			if NecroFlag.Info then
				Necropl:Say("Not While in a Vehicle");
			end
		else
			if Necrox ~= nil and Necroy ~= nil and Necroz ~= nil then
				Necropl:setX(Necrox);
				Necropl:setY(Necroy);
				Necropl:setZ(Necroz);
				Necropl:setLx(Necrox);
				Necropl:setLy(Necroy);
				Necropl:setLz(Necroz);
			else
				-- Tell the Player What Failed
				if NecroFlag.Info then
					if Necrox == nil then
						Necropl:Say("X Coordinate Missing");
					elseif Necroy == nil then
						Necropl:Say("Y Coordinate Missing");
					elseif Necroz == nil then
						Necropl:Say("Z Coordinate Missing");
					end
				end
			end
		end
	end
end

-- Execute Fetch Current Coordinates
function NecroVision:GetCoord()
	if NecroVision.AdminCheck() then
	getSoundManager():PlaySound("NecroForge", false, 0.8);
	local Necropl = getSpecificPlayer(0)
	local Necrosx = round(Necropl:getX(), 2)
	local Necrosy = round(Necropl:getY(), 2)
	local Necrosz = round(Necropl:getZ())
	-- Make X,Y,Z input boxes display current coordinates
		if NecroVision.VehicleBuildTester() and NecroVision.VehicleTester() then
			if NecroFlag.Info then
				Necropl:Say("Not While in a Vehicle");
			end
		else
			NecroChild.NecroCartographyX:setText(tostring(Necrosx));
			NecroChild.NecroCartographyY:setText(tostring(Necrosy));
			NecroChild.NecroCartographyZ:setText(tostring(Necrosz));
		end
	end
end

-- Execute Remove Button
function NecroVision:RemoveItem()
	if NecroVision.AdminCheck() then
	-- Begin Local Variables
	local Necropl = getSpecificPlayer(0)
	local NecroFunctionItem = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].item
	local NecroFunctionState = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].State
	local NecroFunctionExtra = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].Extra
	-- End Local Variables
	getSoundManager():PlaySound("NecroForge", false, 0.8);
	if NecroFunctionState == "Trait" then
		Necropl:getTraits():remove(NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].Extra);
			if NecroFlag.Info then
				Necropl:Say("Trait Removed");
			end
	elseif NecroFunctionState == "NecroChronos" then
		local NecroChronos = getGameTime()
		local NecroChronosDone = true;
		if NecroFunctionExtra == "Hour" then
			if NecroChronos:getTimeOfDay() > 1 then
				NecroChronos:setTimeOfDay(NecroChronos:getTimeOfDay() - 1)
			else
				NecroChronosDone = false;
			end
		elseif NecroFunctionExtra == "Day" then
			if NecroChronos:getDay() > 0 then
				NecroChronos:setDay(NecroChronos:getDay() - 1)
			else
				NecroChronosDone = false;
			end
		elseif NecroFunctionExtra == "Month" then
			if NecroChronos:getMonth() > 0 then
				NecroChronos:setMonth(NecroChronos:getMonth() - 1)
			else
				NecroChronosDone = false;
			end
		end
		if NecroFlag.Info then
			if NecroChronosDone then
				Necropl:Say("Time Moved Backwards");
			else
				Necropl:Say("Cannot Substract Further");
			end
		end
	else
		local Necroitem = InventoryItemFactory.CreateItem(NecroFunctionItem);
		for i = 1,NecroFlag.Count do 
			NecroChild.NecroListen.Remove.Damned:Remove(Necroitem:getType());
		end
	end
	else
	
	end
end

-- Execute Control Function Reset Button
function NecroVision:ResetCounter()
	local Necropl = getSpecificPlayer(0)
	NecroFlag.Ground = false;
	NecroFlag.Count = 1;
	getSoundManager():PlaySound("NecroForge", false, 0.8);
	NecroChild.NecroListen.ResetCounter:setVisible(false);
	if NecroFlag.Info then
		Necropl:Say("All Control Functions Reset");
	end
end

----------------------------------------------
--					  						--
--			  Brush Functionality			--
--					   						--
----------------------------------------------

function NecroVision:Brushes()
	--[[ !!DEBUG!!
	print("[NecroForge] - DEBUG - NecroVision.Brushes is Running")
	--]]
	if NecroVision.BrushCheck() then
	local Necromx = getMouseXScaled();
	local Necromy = getMouseYScaled();
	local Necropl = getSpecificPlayer(0);
	local Necrosz = Necropl:getZ();
	local Necrosx, Necrosy = ISCoordConversion.ToWorld(Necromx, Necromy, Necrosz);
	local Necrosq = getWorld():getCell():getOrCreateGridSquare(Necrosx, Necrosy, Necrosz);
	local NecroRange;
	local NecroFloor;
	local NecroPlant;
	local NecroObject;
	if NecroVision.AdminCheck then
		if Necrosq ~= nil then
			if NecroFlag.BrushType == "Zombie" then
				for i = 1,NecroFlag.Count do 
					createZombie(Necrosx, Necrosy, Necrosz, nil, 0, IsoDirections.N);
				end
			elseif NecroFlag.BrushType == "Crawler" then
				for i = 1,NecroFlag.Count do 
				local NecroCrawler = createZombie(Necrosx, Necrosy, Necrosz, nil, 0, IsoDirections.N);
					NecroCrawler:setFakeDead(true);
					end
			elseif NecroFlag.BrushType == "Fire" then
				Necrosq:StartFire();
			elseif NecroFlag.BrushType == "Explode" then
				Necrosq:explode();
			elseif NecroFlag.BrushType == "Extinguisher" then
				Necrosq:stopFire()
				if isClient() then Necrosq:transmitStopFire() end
			for i=1,Necrosq:getMovingObjects():size() do
				local NecroPawn = Necrosq:getMovingObjects():get(i-1)
				if instanceof(NecroPawn, "IsoGameCharacter") and NecroPawn:isOnFire() then
					if isClient() then NecroPawn:sendStopBurning() else
						NecroPawn:StopBurning()
					end
				end
			end
			elseif NecroFlag.BrushType == "Teleporter" then
				if NecroVision.VehicleTester() then
					if NecroFlag.Info then
						Necropl:Say("Not While in a Vehicle");
					end
				else 
					Necropl:setX(Necrosx);
					Necropl:setY(Necrosy);
					Necropl:setZ(Necrosz);
					Necropl:setLx(Necrosx);
					Necropl:setLy(Necrosy);
					Necropl:setLz(Necrosz);
				end
			elseif NecroFlag.BrushType == "Destroy A" then
				local NecrosqObjs = Necrosq:getObjects();
				local NecrosqSize = NecrosqObjs:size();
				for i = NecrosqSize - 1, 0, -1 do
				local Necroobj = NecrosqObjs:get(i)
				local Necroprop = Necroobj:getProperties()
					if Necroprop:Is(IsoFlagType.solidfloor) and Necroobj:getZ() == 0 then
					else
						if isClient() then sledgeDestroy(Necroobj) else
							Necroobj:getSquare():transmitRemoveItemFromSquare(Necroobj)
							Necroobj:getSquare():RemoveTileObject(Necroobj) -- ToDo: Remove ALl References to RemoveTileObject Method - Generates Errors and is OBSOLETE as of Build 38/Vehicle anyway.
						end
					end
				end
			elseif NecroFlag.BrushType == "Destroy B" then
				local NecrosqObjs = Necrosq:getObjects();
				local NecrosqSize = NecrosqObjs:size();
				for i = NecrosqSize - 1, 0, -1 do
				local Necroobj = NecrosqObjs:get(i)
				local Necroprop = Necroobj:getProperties()
					if Necroprop:Is(IsoFlagType.solidfloor) 
					or instanceof(Necroobj, "IsoDoor")
					or instanceof(Necroobj, "IsoWindow")
					or (Necroobj:getType() == IsoObjectType.doorFrW or Necroobj:getType() == IsoObjectType.doorFrN)
					or (Necroobj:getProperties():Is(IsoFlagType.cutW) or Necroobj:getProperties():Is(IsoFlagType.cutN)) then
					else
						if isClient() then sledgeDestroy(Necroobj) else
							Necroobj:getSquare():transmitRemoveItemFromSquare(Necroobj)
							Necroobj:getSquare():RemoveTileObject(Necroobj) -- ToDo: Remove ALl References to RemoveTileObject Method - Generates Errors and is OBSOLETE as of Build 38/Vehicle anyway.
						end
					end
				end
			elseif NecroFlag.BrushType == "Destroy C" then
				local Necroobj = UIManager.getLastPicked();
				if Necroobj ~= nil then
				local Necroprop = Necroobj:getProperties()
					if Necroprop:Is(IsoFlagType.solidfloor) and Necroobj:getZ() == 0  then
					else
						if isClient() then sledgeDestroy(Necroobj) else
							Necroobj:getSquare():transmitRemoveItemFromSquare(Necroobj)
							Necroobj:getSquare():RemoveTileObject(Necroobj) -- ToDo: Remove ALl References to RemoveTileObject Method - Generates Errors and is OBSOLETE as of Build 38/Vehicle anyway.
						end
					end
				end
			elseif NecroFlag.BrushType == "Keymaker" then
				local Necroobjx = UIManager.getLastPicked();
					if instanceof(Necroobjx, "IsoDoor") or instanceof(Necroobjx, "IsoThumpable") and Necroobjx:isDoor() then
					local keyid;
						if instanceof(Necroobjx, "IsoDoor") then keyid = Necroobjx:checkKeyId() else keyid = Necroobjx:getKeyId() end
						if keyid ~= nil and keyid > 0 then
							local key = InventoryItemFactory.CreateItem("Base.Key"..ZombRandBetween(1,5));
							key:setKeyId(keyid)
							Necropl:getInventory():AddItem(key);
						else
							if NecroFlag.Info then
								Necropl:Say("This Door Doesn't Have a Lock")
							end
						end
					end
			elseif NecroFlag.BrushType == "Lockmaker" then
				local Necroobjx = UIManager.getLastPicked();
					if instanceof(Necroobjx, "IsoDoor") or instanceof(Necroobjx, "IsoThumpable") and Necroobjx:isDoor() then
					local CKeyID = tonumber(NecroChild.NecroBlueprint:getText())
						if CKeyID ~= nil and CKeyID > 9999999 and CKeyID < 100000000 then Necroobjx:setKeyId(CKeyID) else
							if NecroPicked.KeyID ~= nil then
								Necroobjx:setKeyId(NecroPicked.KeyID)
							else
								NecroPicked.KeyID = ZombRandBetween(10000000,99999999);
								Necroobjx:setKeyId(NecroPicked.KeyID);
								if NecroFlag.Info then
									Necropl:Say("KeyID: "..tostring(NecroPicked.KeyID))
								end
							end
						end
						if Necroobjx:IsOpen() then Necroobjx:ToggleDoor(Necropl) end
						Necroobjx:setLockedByKey(true);
						if isClient() then Necroobjx:transmitCompleteItemToServer() end
						end
			elseif NecroFlag.BrushType == "Item Spawner" then
				NecroPicked.Spawner()
			elseif NecroFlag.BrushType == "Barricade" then
				local NecrosqObjs = Necrosq:getObjects();
				local NecrosqSize = NecrosqObjs:size();
				for i = NecrosqSize - 1, 0, -1 do
				local Necroobj = NecrosqObjs:get(i)
				local Necroprop = Necroobj:getProperties()
					if instanceof(Necroobj, "BarricadeAble") then
						if instanceof(Necroobj, "IsoDoor") or (instanceof(Necroobj, "IsoThumpable") and Necroobj:isDoor()) then
							if Necroobj:IsOpen() then
								Necroobj:ToggleDoor(Necropl)
							end
						end
					local Necrobar = IsoBarricade.AddBarricadeToObject(Necroobj, Necropl)
						if NecroFlag.Barricade == "Plank" then
							local Material = InventoryItemFactory.CreateItem("Base.Plank");
							if isClient() then
								local args = {x=Necroobj:getX(), y=Necroobj:getY(), z=Necroobj:getZ(), index=Necroobj:getObjectIndex(), isMetal=false, isMetalBar=false, itemID=Material:getID(), condition=Material:getCondition()}
								sendClientCommand(Necropl, 'object', 'barricade', args)
							else
								Necrobar:addPlank(Necropl, Material)
							end
						elseif NecroFlag.Barricade == "Metal" then
							local Material = InventoryItemFactory.CreateItem("Base.SheetMetal");
							if isClient() then
								local args = {x=Necroobj:getX(), y=Necroobj:getY(), z=Necroobj:getZ(), index=Necroobj:getObjectIndex(), isMetal=true, isMetalBar=false, itemID=Material:getID(), condition=Material:getCondition()}
								sendClientCommand(Necropl, 'object', 'barricade', args)
							else
								Necrobar:addMetal(Necropl, Material)
							end
						elseif NecroFlag.Barricade == "Bars" then
							local Material = InventoryItemFactory.CreateItem("Base.MetalBar");
							if isClient() then
								local args = {x=Necroobj:getX(), y=Necroobj:getY(), z=Necroobj:getZ(), index=Necroobj:getObjectIndex(), isMetal=false, isMetalBar=true, itemID=Material:getID(), condition=Material:getCondition()}
								sendClientCommand(Necropl, 'object', 'barricade', args)
							else
								Necrobar:addMetalBar(Necropl, Material)
							end
						end
					end
				end
			elseif NecroFlag.BrushType == "Electricity" then
				Necrohe = Necrosq:haveElectricity();
				if Necrohe then Necrosq:setHaveElectricity(false) else Necrosq:setHaveElectricity(true) end
				if NecroFlag.Info then
					if Necrohe then Necropl:Say("Electricity Disabled") else Necropl:Say("Electricity Enabled") end
				end
			elseif NecroFlag.BrushType == "Reanimate Corpse" then
				Necrora = Necrosq:getDeadBody();
				if Necrora then Necrora:reanimateNow() end
			elseif NecroFlag.BrushType == "Remove Corpse" then
				local NecrosqObjs = Necrosq:getDeadBodys();
				local NecrosqSize = NecrosqObjs:size();
				for i = NecrosqSize - 1, 0, -1 do
				local Necroobj = NecrosqObjs:get(i)
					Necrosq:removeCorpse(Necroobj, false)
				end
			elseif NecroFlag.BrushType == "Blood Cleaner" then
				if Necrosq:haveBlood() then
					Necrosq:removeBlood(false)
				end
				-- [Tempolary] [ToDo: Rewrite This Entire Function]
			elseif NecroFlag.BrushType == "Blood/Corpse Cleaner" then
				if Necrosq:haveBlood() then
					Necrosq:removeBlood(false)
				end
				local NecrosqObjs = Necrosq:getDeadBodys();
				local NecrosqSize = NecrosqObjs:size();
				for i = NecrosqSize - 1, 0, -1 do
				local Necroobj = NecrosqObjs:get(i)
					Necrosq:removeCorpse(Necroobj, false)
				end
			elseif NecroFlag.BrushType == "Remove Zombie" then
				local NecrosqObjs = Necrosq:getMovingObjects();
				local NecrosqSize = NecrosqObjs:size();
				for i = NecrosqSize - 1, 0, -1 do
				local Necroobj = NecrosqObjs:get(i)
					if instanceof(Necroobj, "IsoZombie") then
						Necroobj:removeFromWorld()
						Necroobj:removeFromSquare()
					end
				end
			------------------------------------------
			-- 			 Terrain Alteration			--
			-- 				  Plants				--
			------------------------------------------
			elseif NecroFlag.BrushType == "Spawn Grass" then
				if NecroFlag.BrushSpec == "Grass" then
					NecroRange = ZombRandBetween(0, 53);
					NecroSprite = ("e_newgrass_1_"..NecroRange);
				elseif NecroFlag.BrushSpec == "GrassWithered" then
					NecroRange = ZombRandBetween(93, 119);
					NecroSprite = ("d_streetcracks_1_"..NecroRange);
				end
				NecroPicked:Alteration(Necrosq, NecroSprite, false)
			elseif NecroFlag.BrushType == "Spawn Plants" then
				if NecroFlag.BrushSpec == "PlantsA" then
					NecroRange = ZombRandBetween(80, 87);
					NecroSprite = ("d_generic_1_"..NecroRange);
				elseif NecroFlag.BrushSpec == "PlantsB" then
					NecroRange = ZombRandBetween(0, 7);
					NecroSprite = ("d_plants_1_"..NecroRange);
				elseif NecroFlag.BrushSpec == "PlantsC" then
					NecroRange = ZombRandBetween(16, 23);
					NecroSprite = ("d_plants_1_"..NecroRange);
				elseif NecroFlag.BrushSpec == "PlantsD" then
					NecroRange = ZombRandBetween(32, 39);
					NecroSprite = ("d_plants_1_"..NecroRange);
				elseif NecroFlag.BrushSpec == "PlantsE" then
					NecroRange = ZombRandBetween(48, 55);
					NecroSprite = ("d_plants_1_"..NecroRange);
				elseif NecroFlag.BrushSpec == "PlantsF" then
					NecroRange = ZombRandBetween(64, 79);
					NecroSprite = ("f_bushes_1_"..NecroRange);
				end
				NecroPicked:Alteration(Necrosq, NecroSprite, false)
			elseif NecroFlag.BrushType == "Spawn Objects" then
				NecroRange = ZombRandBetween(0, 47);
				NecroSprite = ("d_generic_1_"..NecroRange);
				NecroPicked:Alteration(Necrosq, NecroSprite, false)
			------------------------------------------
			-- 			 Terrain Alteration			--
			-- 				  Floors				--
			------------------------------------------
			elseif NecroFlag.BrushType == "Place Floor" then
				if NecroFlag.BrushSpec == "Grass" then
					NecroRange = ZombRandBetween(21, 23);
					NecroSprite =  ("blends_natural_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "GrassLight" then
					NecroRange = ZombRandBetween(37, 39);
					NecroSprite =  ("blends_natural_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "GrassYellow" then
					NecroRange = ZombRandBetween(53, 55);
					NecroSprite =  ("blends_natural_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "Dirt" then
					NecroRange = ZombRandBetween(69, 71);
					NecroSprite =  ("blends_natural_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "Sand" then
					NecroRange = ZombRandBetween(5, 7);
					NecroSprite =  ("blends_natural_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "Gravel" then
					NecroSprite =  ("blends_street_01_48");
				elseif NecroFlag.BrushSpec == "Asphalt" then
					NecroRange = ZombRandBetween(69, 71);
					NecroSprite =  ("blends_street_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "AsphaltDark" then
					NecroRange = ZombRandBetween(85, 87);
					NecroSprite =  ("blends_street_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "AsphaltLight" then
					NecroRange = ZombRandBetween(101, 103);
					NecroSprite =  ("blends_street_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "Rocks" then
					NecroRange = ZombRandBetween(9, 11);
					NecroSprite =  ("floors_exterior_natural_01_"..NecroRange);
				elseif NecroFlag.BrushSpec == "Water" then
					NecroRange = ZombRandBetween(5, 7);
					NecroSprite =  ("blends_natural_02_"..NecroRange);
				end
				if NecroFlag.BrushSpec == "Water" then
					NecroPicked:Alteration(Necrosq, NecroSprite, false)
				else
					NecroPicked:Alteration(Necrosq, NecroSprite, true)
				end
			------------------------------------------
			-- 			Tile/Object Cloner			--
			------------------------------------------
			elseif NecroFlag.BrushType == "Tile/Object Clone" then
				NecroPicked:Creation(Necrosq, NecroPicked.Sprite)
			------------------------------------------
			-- 			Mod Support Brushes			--
			-- 	     Survivors Mod NPC Spawner		--
			------------------------------------------
			-- Mod Related Functions will be moved to their own file in the future.
			elseif NecroFlag.BrushType == "Spawn Survivor" then
				local Survivor = SpawnSurvivor(Necrosq, 0, nil)
				Survivor:getModData().isHostile = false;
			elseif NecroFlag.BrushType == "Spawn Hostile Survivor" then
				local Survivor = SpawnSurvivor(Necrosq, 0, nil)
				Survivor:getModData().isHostile = true;
			end
		else
			if NecroFlag.Info then
				Necropl:Say("No Square Found")
			end
		end
	end
	end
end

-- Execute Brush Highlight
function NecroVision:BrushHighlight()
	--[[ !!DEBUG!!
	print("[NecroForge] - DEBUG - NecroVision.BrushHighlight is Running")
	--]]
	if NecroVision.BrushCheck() then
		local Necromx = getMouseXScaled();
		local Necromy = getMouseYScaled();
		local Necropl = getSpecificPlayer(0);
		local Necroz = math.floor(Necropl:getZ());
		local Necrox, Necroy = ISCoordConversion.ToWorld(Necromx, Necromy, Necroz);
		Necrox = math.floor(Necrox);
		Necroy = math.floor(Necroy);
		local Necrosq = getWorld():getCell():getOrCreateGridSquare(Necrox, Necroy, Necroz);
		if Necrosq ~= nil then
		getCell():setDrag(nil, Necropl:getPlayerNum());
		local NecrosqObjs = Necrosq:getObjects();
		local NecrosqSize = NecrosqObjs:size();
			if NecrosqSize ~= nil and NecrosqSize > 0 then
				for i = NecrosqSize - 1, 0, -1 do
					local Necroobj = NecrosqObjs:get(i)
					if NecroFlag.BrushType == "Destroy A" then
					local Necroprop = Necroobj:getProperties()
						if Necroprop:Is(IsoFlagType.solidfloor) and Necroobj:getZ() == 0 then
						else
							Necroobj:setHighlighted(true)
							Necroobj:setHighlightColor(ColorInfo.new(1,0,0,0.5));
						end
					elseif NecroFlag.BrushType == "Destroy B" then
						local Necroprop = Necroobj:getProperties()
						if Necroprop:Is(IsoFlagType.solidfloor) 
						or instanceof(Necroobj, "IsoDoor")
						or instanceof(Necroobj, "IsoWindow")
						or (Necroobj:getType() == IsoObjectType.doorFrW or Necroobj:getType() == IsoObjectType.doorFrN)
						or (Necroobj:getProperties():Is(IsoFlagType.cutW) or Necroobj:getProperties():Is(IsoFlagType.cutN)) then
						else
							Necroobj:setHighlighted(true)
							Necroobj:setHighlightColor(ColorInfo.new(1,0,0,0.5));
						end
					elseif NecroFlag.BrushType == "Destroy C" then
						local Necroobj = UIManager.getLastPicked();
						if Necroobj ~= nil then
						local Necroprop = Necroobj:getProperties()
							if Necroprop:Is(IsoFlagType.solidfloor) and Necroobj:getZ() == 0 then
							else
								Necroobj:setHighlighted(true)
								Necroobj:setHighlightColor(ColorInfo.new(1,0,0,0.5));
							end
						end
					elseif NecroFlag.BrushType == "Barricade" then
						local Necroprop = Necroobj:getProperties()
						if instanceof(Necroobj, "BarricadeAble") and NecroFlag.Barricade ~= "Unbarricade" then
							Necroobj:setHighlighted(true)
							Necroobj:setHighlightColor(ColorInfo.new(1,0.5,0,0.5));
						end
					elseif NecroFlag.BrushType == "Electricity" then
						local Necrohe = Necrosq:haveElectricity();
						if Necrohe then 
							Necroobj:setHighlighted(true)
							Necroobj:setHighlightColor(ColorInfo.new(0.4,1,0.1,0.5));
						else 
							Necroobj:setHighlighted(true)
							Necroobj:setHighlightColor(ColorInfo.new(1,0,0,0.5)); 
						end
					elseif NecroFlag.BrushType == "Keymaker" or NecroFlag.BrushType == "Lockmaker" then
						local Necroobjx = UIManager.getLastPicked();
						if instanceof(Necroobjx, "IsoDoor") or instanceof(Necroobjx, "IsoThumpable") and Necroobjx:isDoor() then
							Necroobjx:setHighlighted(true)
							Necroobjx:setHighlightColor(ColorInfo.new(0,1,0,0.5));
						end
					elseif NecroFlag.BrushType == "Tile/Object Clone" then
						-- Highlight Moused Over -- [RED] -- Object That can be Picked
						local Necroobjx = UIManager.getLastPicked();
						if Necroobjx ~= nil then
							Necroobjx:setHighlighted(true)
							Necroobjx:setHighlightColor(ColorInfo.new(1,0,0,0.5));
						local Necroobjsq = Necroobjx:getSquare()
						-- Highlight Floor for Moused Over -- [GREEN] -- Floor Underneath Object that can be Picked
							local Necroobj =  Necroobjsq:getFloor()
							if Necroobj ~= nil then
								Necroobj:setHighlighted(true)
								Necroobj:setHighlightColor(ColorInfo.new(0,1,0,0.5));
							end
							-- Highlight Currently Selected Square -- [ORANGE] -- Floor of Square where Object will be Spawned OR Floor Tile that can be Picked
							local Necrospwnsq =  Necrosq:getFloor()
							if Necrospwnsq ~= nil then
								Necrospwnsq:setHighlighted(true)
								Necrospwnsq:setHighlightColor(ColorInfo.new(1,0.75,0,0.5));
							end
						end
						-- Show Ghost Tile of Overlay
						if NecroPicked.Object and NecroFlag.ShowGhost and getTexture(NecroPicked.Sprite) ~= nil then
							if NecroFlag.OverOnly or NecroFlag.OverOnlyTemp then 
								local NecroGhostTile = NecroSpirit:new(NecroPicked.Sprite, Necrox, Necroy, Necroz, Necropl, Necrosq, false, false, NecroPicked.Overlayed, NecroPicked.Overlays, NecroFlag.OverOnlyTemp)
								getCell():setDrag(NecroGhostTile, Necropl:getPlayerNum());
							else
								local NecroGhostTile = NecroSpirit:new(NecroPicked.Sprite, Necrox, Necroy, Necroz, Necropl, Necrosq, false, true, NecroPicked.Overlayed, NecroPicked.Overlays, NecroFlag.OverOnlyTemp)
								getCell():setDrag(NecroGhostTile, Necropl:getPlayerNum());
							end
						else
							getCell():setDrag(nil, Necropl:getPlayerNum());
						end
					else 
						Necroobj:setHighlighted(true)
						Necroobj:setHighlightColor(ColorInfo.new(0,1,0,0.5));
					end
				end
			else
				-- No Floor = Render Floor Helper
				if NecroFlag.BrushType == "Tile/Object Clone" then
					if NecroPicked.Object and NecroFlag.ShowGhost and getTexture(NecroPicked.Sprite) ~= nil then
						if NecroFlag.OverOnly or NecroFlag.OverOnlyTemp then 
							local NecroGhostTile = NecroSpirit:new(NecroPicked.Sprite, Necrox, Necroy, Necroz, Necropl, Necrosq, true, false, NecroPicked.Overlayed, NecroPicked.Overlays, NecroFlag.OverOnlyTemp)
							getCell():setDrag(NecroGhostTile, Necropl:getPlayerNum());
						else
							local NecroGhostTile = NecroSpirit:new(NecroPicked.Sprite, Necrox, Necroy, Necroz, Necropl, Necrosq, true, true, NecroPicked.Overlayed, NecroPicked.Overlays, NecroFlag.OverOnlyTemp)
							getCell():setDrag(NecroGhostTile, Necropl:getPlayerNum());
						end
					else
						local NecroGhostTile = NecroSpirit:new(NecroPicked.Sprite, Necrox, Necroy, Necroz, Necropl, Necrosq, true, false, false, nil, false)
						getCell():setDrag(NecroGhostTile, Necropl:getPlayerNum());
					end
				else
					local NecroGhostTile = NecroSpirit:new(NecroPicked.Sprite, Necrox, Necroy, Necroz, Necropl, Necrosq, true, false, false, nil, false)
					getCell():setDrag(NecroGhostTile, Necropl:getPlayerNum());
				end
			end
		end
	end
end

----------------------------------------------
--					  						--
--			   Tile/Object Cloner			--
--			 General Hotkey Controls		--
--					   						--
----------------------------------------------

function NecroKeyControl(key)
	--[[ !!DEBUG!!
	print("[NecroForge] - DEBUG - NecroKeyControl is Running")
	--]]
		------------------------------------------
		-- 			  Object Picker				--
		------------------------------------------
	if NecroVision.BrushCheck() and NecroFlag.BrushType == "Tile/Object Clone" then
		if key == NecroKeys.TOCPick then
		local Necroobj = UIManager.getLastPicked() 
		NecroPicked:ObjectPicker(Necroobj)
		------------------------------------------
		-- 		  Object Picker Options			--
		------------------------------------------
		-- Replace Overlays
		elseif key == NecroKeys.TOCOverRep then
			local Necropl = getSpecificPlayer(0)
			if NecroFlag.OverRep then NecroFlag.OverRep = false else NecroFlag.OverRep = true end
			if NecroFlag.Info then
				if NecroFlag.OverRep then
					Necropl:Say("Replace Overlays ON")
				else
					Necropl:Say("Replace Overlays OFF")
				end
			end
		-- Only Overlays
		elseif key == NecroKeys.TOCOverOnly then
			local Necropl = getSpecificPlayer(0)
			if NecroFlag.OverOnly then NecroFlag.OverOnly = false else NecroFlag.OverOnly = true end
			if NecroFlag.Info then
				if NecroFlag.OverOnly then
					Necropl:Say("Only Copy/Place Overlays ON")
				else
					Necropl:Say("Only Copy/Place Overlays OFF")
				end
			end
		-- Tile Preview
		elseif key == NecroKeys.TOCGhost then
			local Necropl = getSpecificPlayer(0)
			if NecroFlag.ShowGhost then NecroFlag.ShowGhost = false else NecroFlag.ShowGhost = true end
			if NecroFlag.Info then
				if NecroFlag.ShowGhost then
					Necropl:Say("Show Tile Preview ON")
				else
					Necropl:Say("Show Tile Preview OFF")
				end
			end
		-- Tile/Object Cloner - Rotate Object if Possible [With Arrow Keys]
		-- This Needs to be Redone to use !!ONE!! key instead of FOUR [TODO]
		elseif key == NecroKeys.TOCRotateN or key == NecroKeys.TOCRotateW or key == NecroKeys.TOCRotateS or key == NecroKeys.TOCRotateE then
			if getTexture(NecroPicked.Sprite) ~= nil then
				local Rotate;
				if key == NecroKeys.TOCRotateN then Rotate = NecroPicked.Noffset
				elseif key == NecroKeys.TOCRotateW then Rotate = NecroPicked.Woffset
				elseif key == NecroKeys.TOCRotateS then Rotate = NecroPicked.Soffset
				elseif key == NecroKeys.TOCRotateE then Rotate = NecroPicked.Eoffset end
				if NecroPicked.Facing ~= nil then
					if Rotate ~= 0 then
						NecroPicked.Sprite = NecroPicked.SpriteSheet .. tonumber(NecroPicked.SpriteID + Rotate)
						if NecroPicked.Type == "IsoDoor" or NecroPicked.Type == "IsoWindow" and Rotate == NecroPicked.Noffset then
							NecroPicked.North = true
						elseif NecroPicked.Type == "IsoDoor" or NecroPicked.Type == "IsoWindow" and Rotate == NecroPicked.Woffset then
							NecroPicked.North = false
						end
						NecroPicked.UpdateSprite()
					end
				end
			end
		-- Force Next/Previous Sprite in Current Sprite's Sheet -- Invalid Sprite = Nothing Will Spawn -- It Isn't Perfect But It's Nice to Have
		elseif key == NecroKeys.TOCSpriteN or key == NecroKeys.TOCSpriteP then
			if NecroPicked.Object then
				local num;
				if key == NecroKeys.TOCSpriteN then num = 1 else num = -1 end
				-- Ignore Picked Overlays
				NecroPicked.Overlayed = false;
				-- Get Sprite
				local Target = "_"
				local Index = NecroPicked.Sprite:match(".*"..Target.."()")
				if Index ~= nil then
					NecroPicked.SpriteSheet = NecroPicked.Sprite:sub(1, Index-1);
					NecroPicked.SpriteID = tonumber(NecroPicked.Sprite:sub(Index));
				end
				NecroPicked.Sprite = NecroPicked.SpriteSheet .. tonumber(NecroPicked.SpriteID + num)
				if getTexture(NecroPicked.Sprite) ~= nil then NecroPicked.UpdateSprite() end
				if getTexture(NecroPicked.Sprite) ~= nil then NecroPicked.Floor = NecroPicked.SpriteProps:Is(IsoFlagType.solidfloor) end
				if getTexture(NecroPicked.Sprite) ~= nil and NecroPicked.SpriteProps:Is(IsoFlagType.windowW) or NecroPicked.SpriteProps:Is(IsoFlagType.doorW) then NecroPicked.North = false else NecroPicked.North = true end
				if getTexture(NecroPicked.Sprite) ~= nil and NecroPicked.SpriteProps:Is(IsoFlagType.FloorOverlay) or NecroPicked.SpriteProps:Is(IsoFlagType.WallOverlay) then 
					for i=0, #NecroPicked.Overlays do NecroPicked.Overlays[i]=nil end
					table.insert(NecroPicked.Overlays, tostring(NecroPicked.Sprite))
					NecroFlag.OverOnlyTemp = true;
				else
					for i=0, #NecroPicked.Overlays do NecroPicked.Overlays[i]=nil end
					NecroFlag.OverOnlyTemp = false;
				end
			else
				getSpecificPlayer(0):Say("No Object Data")
			end
		-- Toggle Help
		elseif key == NecroKeys.TOCHelp then
			if NecroFlag.ClonerHelp then NecroFlag.ClonerHelp = false else NecroFlag.ClonerHelp = true end
		-- Remove Object
		elseif key == NecroKeys.TOCRemover then
			local Necroobj = UIManager.getLastPicked();
			NecroPicked:Destruction(Necroobj)
		end
	end
	------------------------------------------
	-- 		  	   Other Options			--
	------------------------------------------
	-- Lockmaker KeyID Selector
	if NecroVision.BrushCheck() and NecroFlag.BrushType == "Lockmaker" then
		-- Pick KeyID From Pre-Existing Door
		local Necropl = getSpecificPlayer(0)
		if key == NecroKeys.TOCPick then
			local Necroobj = UIManager.getLastPicked()
			if instanceof(Necroobj, "IsoDoor") or instanceof(Necroobj, "IsoThumpable") and Necroobj:isDoor() then
				local KeyID;
				if instanceof(Necroobj, "IsoDoor") then KeyID = Necroobj:checkKeyId() else KeyID = Necroobj:getKeyId() end
				if KeyID ~= -1 and KeyID ~= nil then
					NecroPicked.KeyID = KeyID
					if NecroFlag.Info then
						Necropl:Say("KeyID: "..tostring(NecroPicked.KeyID))
					end
				else
					if NecroFlag.Info then
						Necropl:Say("This Door Doesn't Have a Lock")
					end
				end
			end
		-- Generate Random KeyID
		elseif key == NecroKeys.TOCOverOnly then
			NecroPicked.KeyID = ZombRandBetween(10000000,99999999);
			if NecroFlag.Info then
				Necropl:Say("KeyID: "..tostring(NecroPicked.KeyID))
			end
		end
	end
	-- Barricade Selector
	if NecroVision.BrushCheck() and NecroFlag.BrushType == "Barricade" and key == NecroKeys.BrushSpecial then
	local Necropl = getSpecificPlayer(0)
		if NecroFlag.Barricade == "Plank" then NecroFlag.Barricade = "Metal" 
		elseif NecroFlag.Barricade == "Metal" then NecroFlag.Barricade = "Bars" 
		elseif NecroFlag.Barricade == "Bars" then NecroFlag.Barricade = "Plank" end
		if NecroFlag.Info then
			Necropl:Say("Barricade Type: "..NecroFlag.Barricade)
		end
	end
	-- Force Complete Floor Object Replace
	if NecroVision.BrushCheck() and NecroFlag.BrushType == "Place Floor" and key == NecroKeys.BrushSpecial then
	local Necropl = getSpecificPlayer(0)
		if NecroFlag.FloorRep then NecroFlag.FloorRep = false else NecroFlag.FloorRep = true end
		if NecroFlag.Info then
			if NecroFlag.FloorRep then
				Necropl:Say("Force Tile Replacement ON")
			else
				Necropl:Say("Force Tile Replacement OFF")
			end
		end
	end
	-- Z Axis Controller
	if NecroFlag.Flight and key == NecroKeys.MoveUp then
		if NecroFlag.Z < 9 then
			NecroFlag.Z = NecroFlag.Z + 1;
		end
	elseif NecroFlag.Flight and key == NecroKeys.MoveDown then
		if NecroFlag.Z > 0 then
			NecroFlag.Z = NecroFlag.Z - 1;
		end
	end
	-- Main Menu Key Disables Brushes
	if NecroFlag.Brush and key == getCore():getKey("Main Menu") then
		NecroFlag.Brush = false;
		Events.OnMouseMove.Remove(NecroVision.BrushHighlight);
		Events.OnMouseDown.Remove(NecroVision.Brushes);
		NecroFlag.EventBrush = false;
		NecroVision.FunctionWarnCheck()
	end
end

----------------------------------------------
--					  						--
--				Object Picker				--
--					   						--
----------------------------------------------

function NecroPicked:ObjectPicker(_obj)
	local Necropl = getSpecificPlayer(0)
	local Necroobj = _obj
	-- Make Sure an Object is Picked and is an instance of IsoObject Class | Save Relevant Data
	if Necroobj ~= nil and instanceof(Necroobj, "IsoObject") then
		local NecroSprite = Necroobj:getSprite()
		local NecroSpriteProps = NecroSprite:getProperties()
		local NecroSpriteName = NecroSprite:getName()
		local NecroObjectProps = Necroobj:getProperties()
		local NecroSpriteOverlays = Necroobj:getAttachedAnimSprite()
		NecroPicked.Reset()
		NecroPicked.Object = true;
		-- Sprite
		if NecroSpriteName ~= nil then
			NecroPicked.Sprite = NecroSpriteName
		else
			NecroPicked.Object = false;
		end
		-- Sprite Properties
		NecroPicked.SpriteProps = NecroSpriteProps
		-- MultiSprite
		NecroPicked.MultiSprite = NecroSprite:getSpriteGrid() ~= nil
		-- Floor
		if NecroObjectProps:Is(IsoFlagType.solidfloor) then
			NecroPicked.Floor = true;
		else
			NecroPicked.Floor = false
		end
		-- Overlays
		if NecroSpriteOverlays ~= nil then
			if NecroSpriteOverlays:size() > 0 then -- Error Prevention
				for n=1,NecroSpriteOverlays:size() do
					local NecroSprite = NecroSpriteOverlays:get(n-1)
					local NecroOverlaySprite = NecroSprite:getParentSprite():getName();
					table.insert(NecroPicked.Overlays, NecroOverlaySprite)
				end
				NecroPicked.Overlayed = true;
			else
				NecroPicked.Overlayed = false;
			end
		else
			NecroPicked.Overlayed = false;
		end
		-- IsoType
		if instanceof(Necroobj, "IsoTree") then NecroPicked.Type = "IsoTree"
		elseif instanceof(Necroobj, "IsoStove") then NecroPicked.Type = "IsoStove"
		elseif instanceof(Necroobj, "IsoLightSwitch") then NecroPicked.Type = "IsoLightSwitch"
		elseif instanceof(Necroobj, "IsoFireplace") then NecroPicked.Type = "IsoFireplace"
		elseif instanceof(Necroobj, "IsoMultiMedia") then NecroPicked.Type = "IsoMultiMedia"
		elseif instanceof(Necroobj, "IsoJukebox") then NecroPicked.Type = "IsoJukebox"
		elseif instanceof(Necroobj, "IsoDoor") then NecroPicked.Type = "IsoDoor"
		elseif instanceof(Necroobj, "IsoWindow") then NecroPicked.Type = "IsoWindow"
		elseif instanceof(Necroobj, "IsoBarbecue") then NecroPicked.Type = "IsoBarbecue"
		elseif instanceof(Necroobj, "IsoRadio") then NecroPicked.Type = "IsoRadio"
		elseif instanceof(Necroobj, "IsoTelevision") then NecroPicked.Type = "IsoTelevision"
		elseif instanceof(Necroobj, "IsoBarricade") or instanceof(Necroobj, "IsoCurtain") or instanceof(Necroobj, "IsoGenerator") 
		or instanceof(Necroobj, "IsoTrap") or instanceof(Necroobj, "IsoWorldInventoryObject") then 
		NecroPicked.Object = false;
		else 
		NecroPicked.Type = "IsoObject"; 
		end
		-- Extra Properties
		if NecroPicked.Type == "IsoBarbecue" then
			if Necroobj:isPropaneBBQ() then
				NecroPicked.Propane = true;
				if Necroobj:hasPropaneTank() then
					NecroPicked.PropaneTank = InventoryItemFactory.CreateItem("Base.PropaneTank");
				else
					NecroPicked.Object = false;
				end
			else
				if Necroobj:hasFuel() then
					NecroPicked.FuelAmount = Necroobj:getFuelAmount()
				end
			end
		elseif NecroPicked.Type == "IsoDoor" then
			if Necroobj:IsOpen() then
				NecroPicked.Object = false;
			else
				local OpenSprite = Necroobj:getOpenSprite()
				NecroPicked.OpenSprite = OpenSprite:getName()
				NecroPicked.North = Necroobj:getNorth()
				NecroPicked.KeyID = Necroobj:checkKeyId()
			end
		elseif NecroPicked.Type == "IsoWindow" then
			if Necroobj:IsOpen() or Necroobj:isSmashed() then
				NecroPicked.Object = false;
			else
				NecroPicked.North = Necroobj:getNorth()
				NecroPicked.Locked = Necroobj:isLocked()
				NecroPicked.PermaLocked = Necroobj:isPermaLocked()
			end
		elseif NecroPicked.Type == "IsoRadio" or NecroPicked.Type == "IsoTelevision" then
			if instanceof(Necroobj,"IsoWaveSignal") then
				NecroPicked.DeviceData = Necroobj:getDeviceData()
			end
		end
		NecroPicked.UpdateSprite()
	else
		NecroPicked.Object = false;
	end
	-- If Something Failed, Reset Everything
	if not NecroPicked.Object then NecroPicked.Reset() end
	if NecroFlag.Info then
		if NecroPicked.Object then
			Necropl:Say("Object Selected")
		else
			Necropl:Say("Cannot Select This")
		end
	end
end

----------------------------------------------
--					  						--
--			   	 Object Picker				--
--		   Update|Reset Functionality		--
--					  						--
----------------------------------------------

function NecroPicked:UpdateSpriteID()
	if NecroPicked.Sprite and NecroPicked.Facing ~=nil then
	local Target = "_"
	local Index = NecroPicked.Sprite:match(".*"..Target.."()")
		if Index ~= nil then
			NecroPicked.SpriteSheet = NecroPicked.Sprite:sub(1, Index-1);
			NecroPicked.SpriteID = tonumber(NecroPicked.Sprite:sub(Index));
		end
	end
end

function NecroPicked:UpdateSprite()
	if NecroPicked.Sprite then
		NecroPicked.SpriteProps = getSprite(NecroPicked.Sprite):getProperties()
		NecroPicked.Facing = NecroPicked.SpriteProps:Is("Facing") and NecroPicked.SpriteProps:Val("Facing") or nil;
		if NecroPicked.Facing ~= nil then
			NecroPicked.Noffset	= NecroPicked.SpriteProps:Is("Noffset") and tonumber(NecroPicked.SpriteProps:Val("Noffset")) or 0;
			NecroPicked.Soffset	= NecroPicked.SpriteProps:Is("Soffset") and tonumber(NecroPicked.SpriteProps:Val("Soffset")) or 0;
			NecroPicked.Woffset	= NecroPicked.SpriteProps:Is("Woffset") and tonumber(NecroPicked.SpriteProps:Val("Woffset")) or 0;
			NecroPicked.Eoffset	= NecroPicked.SpriteProps:Is("Eoffset") and tonumber(NecroPicked.SpriteProps:Val("Eoffset")) or 0;
			NecroPicked.UpdateSpriteID()
		end
	end
end

function NecroPicked:Reset()
	NecroPicked.Object 		= false;
	NecroPicked.Floor 		= nil;
	NecroPicked.Type 		= nil;
	NecroPicked.Sprite 		= nil;
	NecroPicked.OpenSprite	= nil;
	NecroPicked.Overlayed 	= nil;
	NecroPicked.Propane		= nil;
	NecroPicked.PropaneTank	= nil;
	NecroPicked.FuelAmount	= nil;
	NecroPicked.North		= nil;
	NecroPicked.Locked		= nil;
	NecroPicked.PermaLocked = nil;
	NecroPicked.Health		= nil;
	NecroPicked.MaxHealth	= nil;
	NecroPicked.KeyID		= nil;
	NecroPicked.DeviceData	= nil;
	NecroPicked.Facing		= nil;
	NecroPicked.Noffset		= nil;
	NecroPicked.Soffset		= nil;
	NecroPicked.Woffset		= nil;
	NecroPicked.Eoffset		= nil;
	NecroPicked.SpriteSheet = nil;
	NecroPicked.SpriteID	= nil;
	NecroPicked.SpriteProps = nil;
	NecroPicked.MultiSprite = nil;
	NecroFlag.OverOnlyTemp	= false;
	for i=0, #NecroPicked.Overlays do NecroPicked.Overlays[i]=nil end
end

----------------------------------------------
--					  						--
--			   	 Object Picker				--
--		 Creation|Alteration|Destruction	--
--					  						--
----------------------------------------------

function NecroPicked:Creation(_sq, _spr)
	local Necrosq = _sq
	local Necrospr = _spr
	local NecroFloor;
	local NecroObject;
	if NecroFlag.BrushType == "Tile/Object Clone" then
		if NecroPicked.Object then
			if getTexture(NecroPicked.Sprite) then
				if NecroFlag.OverOnly or NecroFlag.OverOnlyTemp then
					if NecroPicked.Overlayed or NecroFlag.OverOnlyTemp then
					local Necroobj = UIManager.getLastPicked();
						if NecroFlag.OverRep then
							Necroobj:RemoveAttachedAnims() 
							if isClient() then Necroobj:transmitUpdatedSpriteToServer() end
						end
						for k, v in pairs (NecroPicked.Overlays) do
							local NecroOverlay = v;
							Necroobj:AttachExistingAnim(getSprite(NecroOverlay), 0, 0, false, 0, false, 0)
							if isClient() then Necroobj:transmitUpdatedSpriteToServer() end
						end
					else
						local Necroobj = UIManager.getLastPicked();
						if NecroFlag.OverRep then
							Necroobj:RemoveAttachedAnims() 
							if isClient() then Necroobj:transmitUpdatedSpriteToServer() end
						end
					end
				else
					-- Create Floor
					if NecroPicked.Floor then
						local Necroobj = Necrosq:getFloor()
						if Necroobj == nil then
							NecroFloor =  IsoObject.new(Necrosq, Necrospr, false);
							Necrosq:AddSpecialObject(NecroFloor);
							if isClient() then NecroFloor:transmitCompleteItemToServer() end
						else
							local NecroFloor = Necrospr
							Necroobj:setSprite(getSprite(NecroFloor));
							if isClient() then Necroobj:transmitUpdatedSpriteToServer(); end
						end
						if NecroPicked.Overlayed or NecroFlag.OverOnlyTemp then
							local NecroFloor = Necrosq:getFloor()
							if NecroFlag.OverRep then
								NecroFloor:RemoveAttachedAnims() 
								if isClient() then NecroFloor:transmitUpdatedSpriteToServer() end
							end
							for k, v in pairs (NecroPicked.Overlays) do
								local NecroOverlay = v;
								NecroFloor:AttachExistingAnim(getSprite(NecroOverlay), 0, 0, false, 0, false, 0)
							end
							if isClient() then NecroFloor:transmitUpdatedSpriteToServer() end
						else
							if NecroFlag.OverRep then
								local NecroFloor = Necrosq:getFloor()
								NecroFloor:RemoveAttachedAnims() 
								if isClient() then NecroFloor:transmitUpdatedSpriteToServer() end
							end
						end
						Necrosq:disableErosion();
						local args = { x = Necrosq:getX(), y = Necrosq:getY(), z = Necrosq:getZ() }
						sendClientCommand(nil, 'erosion', 'disableForSquare', args)
					else
						-- Create Object, Apply Data
						if NecroPicked.Type == "IsoTree" then
							NecroObject =  IsoTree.new(Necrosq, Necrospr, false);
						elseif NecroPicked.Type == "IsoObject" then
							NecroObject =  IsoObject.new(Necrosq, Necrospr, false);
						elseif NecroPicked.Type == "IsoStove" then
							NecroObject =  IsoStove.new(getCell(), Necrosq, getSprite(Necrospr));
						elseif NecroPicked.Type == "IsoJukebox" then
							NecroObject =  IsoJukebox.new(getCell(), Necrosq, getSprite(Necrospr));
						elseif NecroPicked.Type == "IsoFireplace" then
							NecroObject =  IsoFireplace.new(getCell(), Necrosq, getSprite(Necrospr));
						elseif NecroPicked.Type == "IsoMultiMedia" then
							NecroObject =  IsoMultiMedia.new(getCell(), Necrosq, getSprite(Necrospr));
						elseif NecroPicked.Type == "IsoLightSwitch" then
							NecroObject = IsoLightSwitch.new(getCell(), Necrosq, getSprite(Necrospr), Necrosq:getRoomID());
							NecroObject:addLightSourceFromSprite();
						elseif NecroPicked.Type == "IsoBarbecue" then
							NecroObject =  IsoBarbecue.new(getCell(), Necrosq, getSprite(Necrospr));
							if NecroPicked.Propane then 
								NecroObject:setPropaneTank(NecroPicked.PropaneTank)
							end
							if NecroPicked.FuelAmount ~= nil then
								NecroObject:setFuelAmount(NecroPicked.FuelAmount)
							end
						elseif NecroPicked.Type == "IsoWindow" then
							NecroObject = IsoWindow.new(getCell(), Necrosq, getSprite(Necrospr), NecroPicked.North);
							NecroObject:setIsLocked(NecroPicked.Locked)
							NecroObject:setPermaLocked(NecroPicked.PermaLocked)
						elseif NecroPicked.Type == "IsoDoor" then
							NecroObject = IsoDoor.new(getCell(), Necrosq, getSprite(Necrospr), NecroPicked.North);
							NecroObject:setIsLocked(false)
							NecroObject:setLockedByKey(false)
							NecroObject:setKeyId(NecroPicked.KeyID)
						elseif NecroPicked.Type == "IsoRadio" then
							NecroObject = IsoRadio.new( getCell(), Necrosq, getSprite(Necrospr));
							if NecroPicked.DeviceData ~= nil then
								NecroObject:setDeviceData(NecroPicked.DeviceData);
							end
						elseif NecroPicked.Type == "IsoTelevision" then
							NecroObject = IsoTelevision.new(getCell(), Necrosq, getSprite(Necrospr));
							if NecroPicked.DeviceData ~= nil then
								NecroObject:setDeviceData(NecroPicked.DeviceData);
							end
						else 
							if NecroFlag.Info then
								Necropl:Say("Unsupported Object Type")
							end
						end
						-- Make Object a Container
						if NecroPicked.SpriteProps and NecroObject then
							NecroObject:createContainersFromSpriteProperties()
							for i=1,NecroObject:getContainerCount() do
								NecroObject:getContainerByIndex(i-1):setExplored(true)
							end
						end
						-- Make Object a Water Source
						if NecroPicked.SpriteProps:Is(IsoFlagType.waterPiped) then
							NecroObject:setUsesExternalWaterSource(true);
						end
						-- Apply Overlays
						if NecroPicked.Overlayed then
							for k, v in pairs (NecroPicked.Overlays) do
								local NecroOverlay = v;
								NecroObject:AttachExistingAnim(getSprite(NecroOverlay), 0, 0, false, 0, false, 0)
							end
							if isClient() then NecroObject:transmitUpdatedSpriteToServer() end
						end
						-- Add Object to World
						Necrosq:AddSpecialObject(NecroObject);
						if isClient() then NecroObject:transmitCompleteItemToServer() end
						triggerEvent("OnObjectAdded", NecroObject)
						-- Disable Erosion on Square
						Necrosq:disableErosion();
						local args = { x = Necrosq:getX(), y = Necrosq:getY(), z = Necrosq:getZ() }
						sendClientCommand(nil, 'erosion', 'disableForSquare', args)
					end
				end
			else
				if NecroFlag.Info then
					getSpecificPlayer(0):Say("No Sprite Found")
				end
			end
		else
			if NecroFlag.Info then
				getSpecificPlayer(0):Say("No Object Data")
			end
		end
	end
end

function NecroPicked:Alteration(_sq, _spr, _fl)
	local Necrosq = _sq
	local Necrospr = _spr
	local Necrofl = _fl
	if Necrofl then
		if NecroFlag.FloorRep then
			local NecrosqObjs = Necrosq:getObjects();
			local NecrosqSize = NecrosqObjs:size();
			for i = NecrosqSize - 1, 0, -1 do
			local Necroobj = NecrosqObjs:get(i)
			local Necroprop = Necroobj:getProperties()
				if Necroprop:Is(IsoFlagType.solidfloor) then
					if isClient() then sledgeDestroy(Necroobj) else
						Necroobj:getSquare():transmitRemoveItemFromSquare(Necroobj)
						Necroobj:getSquare():RemoveTileObject(Necroobj)
					end
				end
			end
			NecroObject =  IsoObject.new(Necrosq, Necrospr, false);
			Necrosq:AddSpecialObject(NecroObject);
			if isClient() then NecroObject:transmitCompleteItemToServer() end
		else
			local Necroobj = Necrosq:getFloor()
			if Necroobj == nil then
				NecroObject =  IsoObject.new(Necrosq, Necrospr, false);
				Necrosq:AddSpecialObject(NecroObject);
				if isClient() then NecroObject:transmitCompleteItemToServer() end
			else
				Necroobj:setSprite(getSprite(Necrospr));
				if isClient() then Necroobj:transmitUpdatedSpriteToServer(); end
			end
		end
	else
		NecroObject =  IsoObject.new(Necrosq, Necrospr, false);
		Necrosq:AddSpecialObject(NecroObject);
		if isClient() then NecroObject:transmitCompleteItemToServer() end
	end
	Necrosq:disableErosion();
	local args = { x = Necrosq:getX(), y = Necrosq:getY(), z = Necrosq:getZ() }
	sendClientCommand(nil, 'erosion', 'disableForSquare', args)
end

function NecroPicked:Destruction(_obj)
	local Necroobj = _obj;
	if Necroobj ~= nil then
	local Necroprop = Necroobj:getProperties()
		if Necroprop:Is(IsoFlagType.solidfloor) and Necroobj:getZ() == 0  then
		else
			if isClient() then sledgeDestroy(Necroobj) else
				Necroobj:getSquare():transmitRemoveItemFromSquare(Necroobj)
				Necroobj:getSquare():RemoveTileObject(Necroobj) -- ToDo: Remove ALl References to RemoveTileObject Method - Generates Errors and is OBSOLETE as of Build 38/Vehicle anyway.
			end
		end
	end
end

-- Item Spawner Brush (Requested by Steam User)
function NecroPicked:Spawner()
	local Necromx = getMouseXScaled();
	local Necromy = getMouseYScaled();
	local Necropl = getSpecificPlayer(0);
	local Necroz = math.floor(Necropl:getZ());
	local Necrox, Necroy = ISCoordConversion.ToWorld(Necromx, Necromy, Necroz);
	Necrox = math.floor(Necrox);
	Necroy = math.floor(Necroy);
	local Necrosq = getWorld():getCell():getOrCreateGridSquare(Necrox, Necroy, Necroz);
	if Necrosq ~= nil then
	local Necropl = getSpecificPlayer(0)
	local NecroFunctionItem = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].item
	local NecroFunctionState = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].State
	local NecroFunctionR = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].r
	local NecroFunctionG = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].g
	local NecroFunctionB = NecroChild.NecroCipher.items[NecroChild.NecroCipher.selected].b
		if NecroFunctionItem ~= "NecroForge.NecroFunction" then
			if NecroFunctionR == nil then
				if NecroFunctionState == "Cooked" then
					local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					NecroGroundItem:setCooked(true);
					Necrosq:AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
				elseif NecroFunctionState == "Burnt" then
					local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					NecroGroundItem:setBurnt(true);
					Necrosq:AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
				elseif NecroFunctionState == "Bad" then
					local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					NecroGroundItem:setAge(NecroGroundItem:getOffAge() + 1);
					Necrosq:AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
				elseif NecroFunctionState == "Rotten" then
					local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					NecroGroundItem:setAge(NecroGroundItem:getOffAgeMax());
					Necrosq:AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
				else
					local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
					Necrosq:AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
				end
			else
				local NecroRags = nil;
				local NecroRagsHue = nil;
				local NecroRagsHueI = nil;
				local NecroRagsHueII = nil;
				local NecroRagsHueIII = nil;
				NecroRagsHueI = ((NecroFunctionR) / 255);
				NecroRagsHueII = ((NecroFunctionG) / 255);
				NecroRagsHueIII = ((NecroFunctionB) / 255);
				NecroRagsHue = ColorInfo.new(NecroRagsHueI, NecroRagsHueII, NecroRagsHueIII, 1);
				local NecroGroundItem = InventoryItemFactory.CreateItem(NecroFunctionItem);
				NecroGroundItem:setColor(NecroRagsHue:toColor());
				Necrosq:AddWorldInventoryItem(NecroGroundItem, 0, 0, 0);
			end
		end
	end
end

----------------------------------------------
--					  						--
--			   Debug Information			--
--					   						--
----------------------------------------------

-- Execute Debug Info Display
function NecroVision:DebugInformant()
	-- Based on Coordinate Viewer by RoboMat & Turbotutone
	if NecroFlag.Debug then
		local Necropl = getSpecificPlayer(0)
		if Necropl then
			local Necrost = getSpecificPlayer(0):getStats()
			local Necrobd = getSpecificPlayer(0):getBodyDamage()
			local Necrosq = getSpecificPlayer(0):getCurrentSquare();
			local Necrocl = getSpecificPlayer(0):getCell();
			-- Stats
			local Necrostat01 = Necrobd:getBoredomLevel();
			local Necrostat02 = Necrost:getFatigue();
			local Necrostat03 = Necrost:getHunger();
			local Necrostat04 = Necrost:getThirst();
			local Necrostat05 = Necrost:getAnger();
			local Necrostat06 = Necrost:getPain();
			local Necrostat07 = Necrost:getStress();
			local Necrostat08 = Necrost:getStressFromCigarettes();
			local Necrostat09 = Necrost:getPanic();
			local Necrostat10 = Necrost:getDrunkenness();
			local Necrostat11 = Necrost:getSickness();
			local Necrostat12 = Necrost:getSanity();
			local Necrostat13 = Necrost:getEndurance();
			local Necrostat14 = Necrobd:getTemperature();
			local Necrostat15 = Necrobd:getWetness();
			local Necrostat16 = Necrobd:getUnhappynessLevel();
			local Necrostat17 = Necrost:getNumVisibleZombies();
			local Necrostat18 = Necrost:getNumChasingZombies();
			local Necrostat19 = Necrobd:getHealth();
			local Necrostat20 = Necrobd:getColdStrength();
			local Necrostat21 = Necrobd:getFakeInfectionLevel() 
			local Necrostat22 = Necrobd:getFoodSicknessLevel() 
			local Necrostat23 = Necrobd:getInfectionLevel()
			local Necrostat24 = Necrost:getFear();
			-- Coordinates
			local Necrosx = Necropl:getX();
			local Necrosy = Necropl:getY();
			local Necrosz = Necropl:getZ();
			local Necroscx = math.floor(Necrosx) / 300;
			local Necroscy = math.floor(Necrosy) / 300;
			local Necroschx = math.floor(Necrosx) / 10;
			local Necroschy = math.floor(Necrosy) / 10;
			local Necroslx = math.floor(Necrosx) % 300;
			local Necrosly = math.floor(Necrosy) % 300;
			if Necrosq then -- Check to Prevent Error when Long Distance Teleporting while DebugInformant is Visible.
			local Necrorm = Necrosq:getRoom();
			local Necrozn = Necrosq:getZone();
				if Necrorm then
					Necrormname = Necrosq:getRoom():getName();
				else
					Necrormname = "outside";
				end
				if Necrozn then
					Necroznname = Necrozn:getType();
					Necrozd = Necrozn:getZombieDensity();
				else
					Necroznname = "none";
					Necrozd = "unknown";
				end
			else 
				Necrormname = "undefined";
				Necroznname = "undefined";
				Necrozd = "undefined";
			end
			-- Zombies in the Area
			local Necronz = Necrocl:getZombieList():size();
			-- Time
			local NecroTimeHrs = getGameTime():getHour()
			local NecroTimeMin = getGameTime():getMinutes()
			local NecroTimeDay = getGameTime():getDay()
			local NecroTimeMon = getGameTime():getMonth()
			local NecroTimeYear = getGameTime():getYear()
			
			
			local NecroDebugInfoA = {
			"Debug Information:",
			"",
			"Player Stats:",
			"Health: " .. round(Necrostat19),
			"Temperature: " .. round(Necrostat14),
			"Endurance: " .. round(Necrostat13, 2),
			"Sanity: " .. round(Necrostat12, 2),
			"Pain: " .. round(Necrostat06, 2),
			"Fatigue: " .. round(Necrostat02, 2),
			"Hunger: " .. round(Necrostat03, 2),
			"Thirst: " .. round(Necrostat04, 2),
			"Panic: " .. round(Necrostat09, 2),
			"Anger: " .. round(Necrostat05, 2),
			"Fear: " .. round(Necrostat24, 2),
			"Stress: " .. round(Necrostat07, 2),
			"Cigarette Stress: " .. round(Necrostat08, 2),
			"Unhappyness: " .. round(Necrostat16, 2),
			"Boredom: " .. round(Necrostat01, 2),
			"Drunkenness: " .. round(Necrostat10, 2),
			"Wetness: " .. round(Necrostat15, 2),
			"",
			"Cold Strength: " .. round(Necrostat20, 2),
			"Food Sickness: " .. round(Necrostat22, 2),
			"Sickness: " .. round(Necrostat11, 2),
			"Fake Infection: " .. round(Necrostat21, 2),
			"Infection: " .. round(Necrostat23, 2),
			}
			local NecroDebugInfoB = {
			"Zombie Information:",
			"",
			"Zombies Visible: " .. Necrostat17,
			"Zombies Chasing: " .. Necrostat18,
			"Zombie Density: " .. Necrozd,
			"Real Zombies:" .. Necronz,
			"",
			"Calendar: " .. NecroTimeDay + 1 .. "/" .. NecroTimeMon + 1 .. "/" .. NecroTimeYear,
			"Time: " .. NecroTimeHrs .. ":" .. NecroTimeMin,
			"",
			"Coordinates:",
			"X: " .. math.floor(Necrosx),
			"Y: " .. math.floor(Necrosy),
			"Z: " .. math.floor(Necrosz),
			"",
			"Chunk: " .. math.floor(Necroschx) .. "x" .. math.floor(Necroschy),
			"",
			"Cell: " .. math.floor(Necroscx) .. "x" .. math.floor(Necroscy),
			"",
			"Current Zone: " .. Necroznname,
			"Current Room: " .. Necrormname,
			}
			local NecroText = getTextManager()
			local NecroInformationA = NecroDebugInfoA
			local NecroInformationB = NecroDebugInfoB
				for i = 1, #NecroDebugInfoA do
					NecroInformationA = NecroDebugInfoA[i];
					NecroText:DrawString(UIFont.Small, 65, 5 + (i * 10), NecroInformationA, 1, 1, 1, 1);
				end
				for i = 1, #NecroDebugInfoB do
					NecroInformationB = NecroDebugInfoB[i];
					NecroText:DrawString(UIFont.Small, 190, 5 + (i * 10), NecroInformationB, 1, 1, 1, 1);
				end
			end
	end
	if NecroVision.BrushCheck() and NecroFlag.BrushType == "Tile/Object Clone" and NecroFlag.ClonerHelp then
		local ClonerInfos = {
		"Tile/Object Cloner Hotkeys:",
		"",
		"["..Keyboard.getKeyName(tonumber(NecroKeys.TOCHelp)).."] - Toggle This",
		"",
		"["..Keyboard.getKeyName(tonumber(NecroKeys.TOCPick)).."] - Pick Object [Highlighted in Red]",
		"",
		"["..Keyboard.getKeyName(tonumber(NecroKeys.TOCRemover)).."] - Remove Object [Highlighted in Red]",
		"",
		"["..Keyboard.getKeyName(tonumber(NecroKeys.TOCOverRep)).."] - Replace Overlays",
		"",
		"["..Keyboard.getKeyName(tonumber(NecroKeys.TOCOverOnly)).."] - Only Pick\\Place Overlays",
		"",
		"["..Keyboard.getKeyName(tonumber(NecroKeys.TOCGhost)).."] - Toggle Tile Preview",
		"",
		"["..Keyboard.getKeyName(tonumber(NecroKeys.TOCSpriteP)).."] - Previous Sprite in Current Sheet",
		"",
		"["..Keyboard.getKeyName(tonumber(NecroKeys.TOCSpriteN)).."] - Next Sprite in Current Sheet",
		"",
		"[Arrow Keys] - Rotate Object",
		"",
		"[Left Mouse] - Place Object",
		"",
		"Currently Picked:",
		"Type - "..tostring(NecroPicked.Type),
		"Sprite - "..tostring(NecroPicked.Sprite),
		"Floor - "..tostring(NecroPicked.Floor),
		"Overlayed - "..tostring(NecroPicked.Overlayed),
		"Rotateable - "..tostring(NecroPicked.Facing~=nil),
		}
		local XPos;
		local YPos;
		if NecroFlag.Debug then YPos = 265; XPos = 25 else YPos = 5; XPos = 65 end
		local NecroText = getTextManager()
		
		local HelpText = ClonerInfos
		for i = 1, #ClonerInfos do
			HelpText = ClonerInfos[i];
			NecroText:DrawString(UIFont.Small, XPos, YPos + (i * 10), HelpText, 1, 1, 1, 1);
		end
	end
end

local function round(num, numDecimalPlaces)
  if numDecimalPlaces and numDecimalPlaces>0 then
    local mult = 10^numDecimalPlaces
    return math.floor(num * mult + 0.5) / mult
  end
  return math.floor(num + 0.5)
end

----------------------------------------------
--					  						--
--	    Debug Checks/Functions/Disabler		--
--					   						--
----------------------------------------------

-- Debug/Brush/Admin Check
function NecroVision:BrushCheck()
	if NecroFlag.Brush then
		return true
	else
		return false
	end
end

function NecroVision:DebugCheck()
	if NecroFlag.Ghost or NecroFlag.God or NecroFlag.Farm or NecroFlag.Build or ISHealthPanel.cheat or NecroFlag.Noclip or NecroFlag.Debug or NecroFlag.Weight or NecroFlag.Flight then
		return true
	else
		return false
	end
end

function NecroVision:AdminCheck()
	if isClient() == true and isAdmin() == true or isClient() == false and isAdmin() == false then
		return true
	else
		return false
	end
end

function NecroVision:VehicleBuildTester()
	if (BaseVehicle ~= nil) then
		return true
	else
		return false
	end
end

function NecroVision:VehicleTester()
	if (BaseVehicle ~= nil) then
		if getSpecificPlayer(0):getVehicle() ~= nil then
			return true
		else
			return false
		end
	end
end

function NecroVision:Guardian()
	if NecroVision.AdminCheck() then
		NecroPorthole:setVisible(true);
		Events.OnTick.Remove(NecroVision.Guardian);
		if isClient() then
			print("[NecroForge] - Authorized - User is Admin")
			NecroChild.title = "- NecroForge - Admin Only -";
		else
			print("[NecroForge] - Authorized - Single Player")
		end
		print("[NecroForge] - Init Events")
		Events.OnTickEvenPaused.Add(NecroVision.Tick);
		Events.OnKeyPressed.Add(NecroWatcher);
	else
		NecroPorthole:setVisible(false);
	end
end

function NecroVision:FunctionWarnCheck()
	-- Debug Function Checker
	if NecroVision.DebugCheck() then
		if NecroFlag.EventDebug then
		else
		Events.OnTick.Add(NecroVision.Debug);
		NecroFlag.EventDebug = true;
		end
	else
		Events.OnTick.Remove(NecroVision.Debug);
		NecroFlag.EventDebug = false;
	end
	if NecroVision.BrushCheck() then
		if NecroFlag.EventBrush then
		else
		Events.OnMouseMove.Add(NecroVision.BrushHighlight);
		Events.OnMouseDown.Add(NecroVision.Brushes);
		NecroFlag.EventBrush = true;
		end
	else
		Events.OnMouseMove.Remove(NecroVision.BrushHighlight);
		Events.OnMouseDown.Remove(NecroVision.Brushes);
		NecroFlag.EventBrush = false;
	end
	if NecroVision.BrushCheck() or NecroVision.DebugCheck() then
		if NecroFlag.EventOnKey then else NecroFlag.EventOnKey = true; Events.OnKeyPressed.Add(NecroKeyControl); end
		NecroFunctionWarn:setVisible(true);
	else
		Events.OnKeyPressed.Remove(NecroKeyControl);
		NecroFlag.EventOnKey = false;
		NecroFunctionWarn:setVisible(false);
	end
	-- Necro Counter/Ground Spawn Reset Button Check
	if NecroFlag.Ground or NecroFlag.Count ~= 1 then
		NecroChild.NecroListen.ResetCounter:setVisible(true);
	else
		NecroChild.NecroListen.ResetCounter:setVisible(false);
	end
end

-- Execute God Mode
function NecroVision:Debug()
	--[[ !!DEBUG!!
	print("[NecroForge] - DEBUG - NecroVision.Debug is Running")
	--]]
	NecroFlag.EventDebug = true;
	if NecroFlag.God and NecroVision.AdminCheck then
	local Necropl = getSpecificPlayer(0)
	local Necrost = Necropl:getStats()
	local Necrobd = Necropl:getBodyDamage()
		Necrobd:setBoredomLevel(0);
		Necrost:setFatigue(0);
		Necrost:setHunger(0);
		Necrost:setThirst(0);
		Necrost:setAnger(0);
		Necrost:setPain(0);
		Necrost:setStress(0);
		Necrost:setStressFromCigarettes(0);
		Necrost:setPanic(0);
		Necrost:setDrunkenness(0);
		Necrost:setSickness(0);
		Necrost:setSanity(1);
		Necrost:setEndurance(1);
		Necrobd:setTemperature(30);
		Necrobd:setWetness(0);
		Necrobd:setUnhappynessLevel(0);
		Necrobd:RestoreToFullHealth();
		Necropl:setTimeSinceLastSmoke(0);
	end
	if NecroFlag.Flight then
		local Necropl = getSpecificPlayer(0)
		local Necrocl = getWorld():getCell()
		local Necrox = Necropl:getX()
		local Necroy = Necropl:getY()
		local Necroz = Necropl:getZ()
		Necropl:setZ(NecroFlag.Z)
		Necropl:setbFalling(false)
		Necropl:setFallTime(0)
		Necropl:setLastFallSpeed(0)
		Necrocl:getOrCreateGridSquare(Necrox, Necroy, Necroz);
	end
end

function NecroVision:DisableDebug()
	getSoundManager():PlaySound("NecroForge", false, 0.8);
	local Necropl = getSpecificPlayer(0)
	-- Disable Debug Flags
	NecroFlag.Farm = false;
	NecroFlag.Build = false;
	NecroFlag.Ghost = false;
	NecroFlag.God = false;
	NecroFlag.Noclip = false;
	NecroFlag.Debug = false;
	NecroFlag.Weight = false;
	NecroFlag.Brush = false;
	if NecroFlag.Flight then Necropl:setZ(0) end -- Suicide Prevention
	NecroFlag.Flight = false;
	NecroFlag.BrushType = nil;
	NecroFlag.BrushSpec = nil;
	-- Disable Cheat Modes
	ISFarmingMenu.cheat = false;
	ISBuildMenu.cheat = false;
	ISHealthPanel.cheat = false;
	-- Restore Player Variables
	Necropl:setGhostMode(false)
	Necropl:setNoClip(false)
	Necropl:setMaxWeightBase(8);
	-- Remove Events
	Events.OnTick.Remove(NecroVision.Debug);
	Events.OnKeyPressed.Remove(NecroKeyControl);
	NecroFlag.EventDebug = false;
	Events.OnMouseMove.Remove(NecroVision.BrushHighlight);
	Events.OnMouseDown.Remove(NecroVision.Brushes);
	NecroFlag.EventBrush = false;
	getCell():setDrag(nil, Necropl:getPlayerNum());
	Events.OnKeyPressed.Remove(NecroKeyControl);
	NecroFlag.EventOnKey = false;
	-- Hide Warning Button and Informant
	NecroFunctionWarn:setVisible(false);
	if NecroFlag.Info then
		Necropl:Say("All Debug Functions Disabled");
	end
end

----------------------------------------------
--					  						--
--			  Misc Core Functions			--
--					   						--
----------------------------------------------

function NecroScanRefresh()
    if NecroChild ~= nil then
        NecroChild.NecroCipher:setYScroll(0);
        if NecroChild.NecroScanI ~= nil then
            NecroChild.NecroScanI.parent = NecroChild.NecroCipher;
            NecroChild.NecroScanI:updatePos();
        end
        if NecroChild.NecroScanII ~= nil then
            NecroChild.NecroScanII.parent = NecroChild.NecroCipher;
            NecroChild.NecroScanII:updatePos();
        end
    end
end

function NecroVision:Tick()
    if NecroChild ~= nil then
        if NecroChild.NecroStudy ~= nil then
            if not NecroChild.isCollapsed then
				if NecroChild.NecroStudy.Study ~= NecroChild.NecroStudy:getText() then
					if not string.find(NecroChild.NecroStudy:getText(), "%c") then
						NecroChild.NecroStudy.Study = NecroChild.NecroStudy:getText();
					else
						NecroChild.NecroStudy:setText(NecroChild.NecroStudy.Study);
					end
						NecroChild.NecroStudy.Patience = 0;
				elseif NecroChild.NecroStudy.Patience == 15 then
                    NecroChild.NecroStudy.Patience = nil;
					NecroSpeak();
				elseif NecroChild.NecroStudy.Patience ~= nil then
                   NecroChild.NecroStudy.Patience = NecroChild.NecroStudy.Patience + 1;
				end
			end
		end
	end
end

function NecroVision:Manifest()
	if NecroVision.AdminCheck() then
		if not NecroChild:getIsVisible() then
			NecroChild:setVisible(true);
			if NecroChild.advocate then
				getSoundManager():PlaySound("NecroWarden", false, 0.8);
				NecroChild.advocate = not NecroChild.advocate;
			end
		else
			NecroChild:setVisible(false);
		end
	end
end

function NecroWatcher(key)
	if NecroVision.AdminCheck() then
    if NecroChild then
        if NecroChild.NecroDimension then
	        if NecroChild.NecroDimension.Toggle.Binding then
    	        if key == 1 then
    	            NecroVision:Bind()
    	        else
    	            NecroChild.Toggle = key;
    	            NecroVision:Consort();
                    NecroVision:Bind();
    	        end
    	    else
        	    if key == tonumber(NecroChild.Toggle) then
                    NecroVision:Manifest();
        	    end
            end
        end
    end
	end
end

Events.OnGameStart.Add(NecroVision.Commence);
Events.OnPostUIDraw.Add(NecroVision.DebugInformant);

----------------------------------------------
--					  						--
--		   Internal Debug Functions			--
--	   Unless Needed Leave Commented Out	--
--					   						--
----------------------------------------------
--[[
-- Displays the Current State of all NecroForge Flags
function NecroPicked.PickerDebug()
	NecroFlag.ClonerHelp = false;
	local PickerFlags = {
	"NecroPicked.Object: "..tostring(NecroPicked.Object),
	"NecroPicked.Floor: "..tostring(NecroPicked.Floor),
	"NecroPicked.Type: "..tostring(NecroPicked.Type),
	"NecroPicked.Sprite: "..tostring(NecroPicked.Sprite),
	"NecroPicked.OpenSprite: "..tostring(NecroPicked.OpenSprite),
	"NecroPicked.Overlayed: "..tostring(NecroPicked.Overlayed),
	"NecroPicked.Propane: "..tostring(NecroPicked.Propane),
	"NecroPicked.PropaneTank: "..tostring(NecroPicked.PropaneTank),
	"NecroPicked.FuelAmount: "..tostring(NecroPicked.FuelAmount),
	"NecroPicked.North: "..tostring(NecroPicked.North),
	"NecroPicked.Locked: "..tostring(NecroPicked.Locked),
	"NecroPicked.PermaLocked: "..tostring(NecroPicked.PermaLocked),
	"NecroPicked.Health: "..tostring(NecroPicked.Health),
	"NecroPicked.MaxHealth	: "..tostring(NecroPicked.MaxHealth),
	"NecroPicked.KeyID: "..tostring(NecroPicked.KeyID),
	"NecroPicked.DeviceData	: "..tostring(NecroPicked.DeviceData),
	"NecroPicked.Facing: "..tostring(NecroPicked.Facing),
	"NecroPicked.Noffset: "..tostring(NecroPicked.Noffset),
	"NecroPicked.Soffset: "..tostring(NecroPicked.Soffset),
	"NecroPicked.Woffset: "..tostring(NecroPicked.Woffset),
	"NecroPicked.Eoffset: "..tostring(NecroPicked.Eoffset),
	"NecroPicked.SpriteSheet: "..tostring(NecroPicked.SpriteSheet),
	"NecroPicked.SpriteID: "..tostring(NecroPicked.SpriteID),
	"NecroPicked.SpriteProps: "..tostring(NecroPicked.SpriteProps),
	"NecroPicked.MultiSprite: "..tostring(NecroPicked.MultiSprite),
	"NecroFlag.OverOnlyTemp: "..tostring(NecroFlag.OverOnlyTemp),
	}
	local NecroFlags = {
	"NecroFlag.God: "..tostring(NecroFlag.God),
	"NecroFlag.Build: "..tostring(NecroFlag.Build),
	"NecroFlag.Farm: "..tostring(NecroFlag.Farm),
	"NecroFlag.Ghost: "..tostring(NecroFlag.Ghost),
	"NecroFlag.Noclip: "..tostring(NecroFlag.Noclip),
	"NecroFlag.Flight: "..tostring(NecroFlag.Flight),
	"NecroFlag.SpeedLimiter: "..tostring(NecroFlag.SpeedLimiter),
	"NecroFlag.SuperSpeed: "..tostring(NecroFlag.SuperSpeed),
	"NecroFlag.Weight: "..tostring(NecroFlag.Weight),
	"NecroFlag.Ground: "..tostring(NecroFlag.Ground),
	"NecroFlag.Debug: "..tostring(NecroFlag.Debug),
	"NecroFlag.Info: "..tostring(NecroFlag.Info),
	"NecroFlag.Icons: "..tostring(NecroFlag.Icons),
	"NecroFlag.Count: "..tostring(NecroFlag.Count),
	"NecroFlag.Z: "..tostring(NecroFlag.Z),
	"NecroFlag.EventDebug: "..tostring(NecroFlag.EventDebug),
	"NecroFlag.EventBrush: "..tostring(NecroFlag.EventBrush),
	"NecroFlag.EventOnKey: "..tostring(NecroFlag.EventOnKey),
	"NecroFlag.Brush: "..tostring(NecroFlag.Brush),
	"NecroFlag.BrushType: "..tostring(NecroFlag.BrushType),
	"NecroFlag.BrushSpec: "..tostring(NecroFlag.BrushSpec),
	"NecroFlag.Barricade: "..tostring(NecroFlag.Barricade),
	"NecroFlag.FloorRep: "..tostring(NecroFlag.FloorRep),
	"NecroFlag.OverRep: "..tostring(NecroFlag.OverRep),
	"NecroFlag.OverOnly: "..tostring(NecroFlag.OverOnly),
	"NecroFlag.ShowGhost: "..tostring(NecroFlag.ShowGhost),
	"NecroFlag.ClonerHelp: "..tostring(NecroFlag.ClonerHelp),
	"NecroFlag.ListMin: "..tostring(NecroFlag.ListMin),
	"NecroFlag.ListMax: "..tostring(NecroFlag.ListMax),
	"NecroFlag.ListStep: "..tostring(NecroFlag.ListStep),
	"NecroFlag.ListNum: "..tostring(NecroFlag.ListNum),
	"NecroFlag.ListNumMax: "..tostring(NecroFlag.ListNumMax),
	}
	local NecroText = getTextManager()
	local PickerFlagText = PickerFlags
	for i = 1, #PickerFlags do
		PickerFlagText = PickerFlags[i];
		NecroText:DrawString(UIFont.Small, 245, 5 + (i * 10), PickerFlagText, 1, 1, 1, 1);
	end
	local NecroFlagText = NecroFlags
	for i = 1, #NecroFlags do
		NecroFlagText = NecroFlags[i];
		NecroText:DrawString(UIFont.Small, 65, 5 + (i * 10), NecroFlagText, 1, 1, 1, 1);
	end
end

Events.OnPostUIDraw.Add(NecroPicked.PickerDebug);
--]]